/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

/*  Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
    rights reserved.

    License to copy and use this software is granted provided that it
    is identified as the "RSA Data Security, Inc. MD5 Message-Digest
    Algorithm" in all material mentioning or referencing this software
    or this function.

    License is also granted to make and use derivative works provided
    that such works are identified as "derived from the RSA Data
    Security, Inc. MD5 Message-Digest Algorithm" in all material
    mentioning or referencing the derived work.

    RSA Data Security, Inc. makes no representations concerning either
    the merchantability of this software or the suitability of this
    software for any particular purpose. It is provided "as is"
    without express or implied warranty of any kind.
    These notices must be retained in any copies of any part of this
    documentation and/or software.
 */
#ifndef _oscl_checksum_md5_md5h_
#define _oscl_checksum_md5_md5h_
#include "oscl/compiler/types.h"

/** */
namespace Oscl {
/** */
namespace Checksum {
/** */
namespace MD5 {

enum{digestSize=16};

/* MD5 context. */
class Calculator {
	public:
		/** state (ABCD) */
		Unsigned32	_state[4];
		/** number of bits, modulo 2^64 (lsb first) */
		Unsigned32	_count[2];
		/** input buffer */
		unsigned char	_buffer[64];
	public:
		/** */
		Calculator() throw();
		/** */
		~Calculator();
		/** */
		void	update(const void* input, unsigned inputLen) throw();
		/** */
		void	final(unsigned char digest[digestSize]) throw();
		/** */
		void	reset() throw();
	};

}
}
}

#endif
