/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "service.h"

using namespace Oscl::Datagram::RX::Contiguous;

Service::Service(	Oscl::Mt::Itc::PostMsgApi&			papi,
					Oscl::Pdu::FWD::Api&				receiver
					) throw():
		_sync(*this,papi),
		_streamPdu(papi,receiver),
		_myPapi(papi),
		_receiver(receiver)
		{
	}

Oscl::Datagram::TX::Contiguous::Req::Api::SAP&	Service::getInputSAP() throw(){
	return _sync.getSAP();
	}

Oscl::Datagram::TX::Contiguous::Api&	Service::getSyncApi() throw(){
	return _sync;
	}

void	Service::request(	Oscl::Datagram::TX::
							Contiguous::Req::Api::TxReq&	msg
							) throw(){
	_streamPdu._part.open();
	_streamPdu._part.append(msg.getPayload()._datagram,msg.getPayload()._length);
	_streamPdu._part.close(0);

	msg.returnToSender();
	}

