/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_est_mdp860_scc1_phyapih_
#define _oscl_drv_est_mdp860_scc1_phyapih_
#include "oscl/bits/ioapi.h"

/** */
namespace Oscl {
/** */
namespace Est {
/** */
namespace Mdp860 {
/** */
namespace SCC1 {

/** */
class PhyApi {
	public:
		/** */
		virtual Bits::InputApi&	getMc68160RxPin() throw()=0;
		/** */
		virtual Bits::InputApi&	getMc68160RxClkPin() throw()=0;
		/** */
		virtual Bits::InputApi&	getMc68160RenaPin() throw()=0;
		/** */
		virtual Bits::InputApi&	getMc68160ClsnPin() throw()=0;
		/** */
		virtual Bits::InputApi&	getMc68160TxPin() throw()=0;
		/** */
		virtual Bits::InputApi&	getMc68160TenaPin() throw()=0;
		/** */
		virtual Bits::InputApi&	getMc68160TxClkPin() throw()=0;
		/** */
		virtual Bits::InOutApi&	getMc68160TpenPin() throw()=0;
		/** */
		virtual Bits::InOutApi&	getMc68160AportPin() throw()=0;
		/** */
		virtual Bits::InOutApi&	getMc68160TpacpePin() throw()=0;
		/** */
		virtual Bits::InOutApi&	getMc68160TpsqelPin() throw()=0;
		/** */
		virtual Bits::InOutApi&	getMc68160TpfuldlPin() throw()=0;
		/** */
		virtual Bits::InOutApi&	getMc68160LoopPin() throw()=0;
	};

}
}
}
}


#endif
