/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "oscl/hw/est/mdp860p/map.h"
#include "oscl/entropy/random128.h"
#include "oscl/entropy/random.h"
#include "oscl/checksum/md5/calculator.h"

/** */
namespace Oscl {
/** */
namespace Entropy {
/** */
namespace Random128 {

/** */
void	fetch(unsigned char	buffer[bufferSize]) throw(){
	Oscl::Checksum::MD5::Calculator	csum;

	unsigned long	rv	= OsclEntropyGetRandom();
	csum.update(&rv,sizeof(rv));

	csum.update(&Mpc860PQUICC.cpmtimer.tcn1,sizeof(Mpc860PQUICC.cpmtimer.tcn1));
	csum.update(&Mpc860PQUICC.cpmtimer.tcn2,sizeof(Mpc860PQUICC.cpmtimer.tcn2));
	csum.update(&Mpc860PQUICC.cpmtimer.tcn3,sizeof(Mpc860PQUICC.cpmtimer.tcn3));
	csum.update(&Mpc860PQUICC.cpmtimer.tcn4,sizeof(Mpc860PQUICC.cpmtimer.tcn4));
	csum.update(&Mpc860PQUICC.si.sirp,sizeof(Mpc860PQUICC.si.sirp));

	csum.update(&Mpc860PQUICC.pram1.other.scc,sizeof(Oscl::Mot8xx::Pram::Header));
	csum.update(&Mpc860PQUICC.pram2.other.scc,sizeof(Oscl::Mot8xx::Pram::Header));
	csum.update(&Mpc860PQUICC.pram2.other.scc,sizeof(Oscl::Mot8xx::Pram::Header));
	csum.final(buffer);
	}

}
}
}

