/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_mot_mc68160_apih_
#define _oscl_mot_mc68160_apih_

/** */
namespace Oscl {
/** */
namespace Motorola {
/** */
namespace MC68160 {

/** */
class Api {
	public:
		/** */
		virtual void	reset() throw()=0;

		/** */
		virtual void	selectAUI() throw()=0;
		/** */
		virtual void	selectTwistedPair() throw()=0;

		/** */
		virtual void	selectAuto() throw()=0;

		/** */
		virtual void	enableHeartbeat() throw()=0;
		/** */
		virtual void	disableHeartbeat() throw()=0;

		/** */
		virtual void	enableAutoPolarityCorrection() throw()=0;
		/** */
		virtual void	disableAutoPolarityCorrection() throw()=0;

		/** */
		virtual void	enableFullDuplex() throw()=0;
		/** */
		virtual void	disableFullDuplex() throw()=0;

		/** */
		virtual void	enableLoopMode() throw()=0;
		/** */
		virtual void	disableLoopMode() throw()=0;

		/** */
		virtual bool	auiPortSelected() const throw()=0;
	};

}
}
}

#endif
