/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc860_porta_pa3h_
#define _oscl_drv_mot_mpc860_porta_pa3h_
#include "pa3api.h"
#include "oscl/bits/port.h"
#include "oscl/bits/iobit.h"
#include "oscl/hw/motorola/mpc8xx/portreg.h"

/** */
namespace Oscl{
/** */
namespace Mot860{
/** */
namespace PortA {

/** */
class PA3 : public PA3Api {
	private:
		/** */
		enum{_bitNum=((sizeof(Mot8xx::Port::PADAT::Reg)*8)-1-3)};
		/** */
		enum{_mask=(1<<_bitNum)};
		/** */
		Bits::IoBit<Mot8xx::Port::PADAT::Reg,_bitNum,true>	_port;
		/** */
		Bits::IoBit<Mot8xx::Port::PADIR::Reg,_bitNum,true>	_padir;
		/** */
		Bits::IoBit<Mot8xx::Port::PAPAR::Reg,_bitNum,true>	_papar;
		/** */
		Bits::IoBit<Mot8xx::Port::PAODR::Reg,_bitNum,true>	_paodr;
		/** */
		Bits::FieldApi<Mot8xx::Port::PADAT::Reg>&			_reservation;
	public:
		/** */
		PA3(	Bits::FieldApi<Mot8xx::Port::PADAT::Reg>&	port,
				Bits::FieldApi<Mot8xx::Port::PADIR::Reg>&	padir,
				Bits::FieldApi<Mot8xx::Port::PAPAR::Reg>&	papar,
				Bits::FieldApi<Mot8xx::Port::PAODR::Reg>&	paodr,
				Bits::FieldApi<Mot8xx::Port::PADAT::Reg>&	reservation
				) throw();

	public: // Mpc8xx::IoReserve::IOApi
		/** */
		Bits::InputApi&		reserveInput() throw();
		/** */
		Bits::OutputApi&	reserveOutput() throw();
		/** */
		Bits::InOutApi&		reserveInOut() throw();

	public:	// CLK::CLK5Api
		/** */
		Bits::InputApi&	reserveCLK5() throw();

	public:	// TIN::TIN3Api
		/** */
		Bits::InputApi&	reserveTIN3() throw();

	public:	// BRGO::BRGO3Api
		/** */
		Bits::InputApi&	reserveBRGO3() throw();

	private:
		/** */
		void	reserve() throw();
	};

}
}
}


#endif
