/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc860_porta_pa6apih_
#define _oscl_drv_mot_mpc860_porta_pa6apih_
#include "oscl/driver/motorola/mpc8xx/ioreserve/io.h"
#include "oscl/driver/motorola/mpc8xx/ioreserve/clk/clk2.h"
#include "oscl/driver/motorola/mpc8xx/ioreserve/tout/tout1.h"

/** */
namespace Oscl{
/** */
namespace Mot860{
/** */
namespace PortA {

/** */
class PA6Api :
	public Mpc8xx::IoReserve::IOApi,
	public Mpc8xx::IoReserve::CLK::CLK2Api,
	public Mpc8xx::IoReserve::TOUT::TOUT1Api
	{
	public: // IOApi
		/** */
		virtual Bits::InputApi&		reserveInput() throw()=0;
		/** */
		virtual Bits::OutputApi&	reserveOutput() throw()=0;
		/** */
		virtual Bits::InOutApi&		reserveInOut() throw()=0;

	public:	// CLK::CLK2Api
		/** */
		virtual Bits::InputApi&	reserveCLK2() throw()=0;

	public:	// TOUT::TOUT1Api
		/** */
		virtual Bits::InputApi&	reserveTOUT1() throw()=0;
	};

}
}
}

#endif
