/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc860_portb_pb27h_
#define _oscl_drv_mot_mpc860_portb_pb27h_
#include "pb27api.h"
#include "oscl/bits/port.h"
#include "oscl/bits/iobit.h"
#include "oscl/hw/motorola/mpc8xx/portreg.h"

/** */
namespace Oscl{
/** */
namespace Mot860{
/** */
namespace PortB {

/** */
class PB27 : public PB27Api {
	private:
		/** */
		enum{_bitNum=((sizeof(Mot8xx::Port::PBDAT::Reg)*8)-1-27)};
		/** */
		enum{_mask=(1<<_bitNum)};
		/** */
		Bits::IoBit<Mot8xx::Port::PBDAT::Reg,_bitNum,true>	_port;
		/** */
		Bits::IoBit<Mot8xx::Port::PBDIR::Reg,_bitNum,true>	_pbdir;
		/** */
		Bits::IoBit<Mot8xx::Port::PBPAR::Reg,_bitNum,true>	_pbpar;
		/** */
		Bits::IoBit<Mot8xx::Port::PBODR::Reg,_bitNum,true>	_pbodr;
		/** */
		Bits::FieldApi<Mot8xx::Port::PBDAT::Reg>&			_reservation;
	public:
		/** */
		PB27(	Bits::FieldApi<Mot8xx::Port::PBDAT::Reg>&	port,
				Bits::FieldApi<Mot8xx::Port::PBDIR::Reg>&	pbdir,
				Bits::FieldApi<Mot8xx::Port::PBPAR::Reg>&	pbpar,
				Bits::FieldApi<Mot8xx::Port::PBODR::Reg>&	pbodr,
				Bits::FieldApi<Mot8xx::Port::PBDAT::Reg>&	reservation
				) throw();

	public: // Mpc8xx::IoReserve::IOApi
		/** */
		Bits::InputApi&		reserveInput() throw();
		/** */
		Bits::OutputApi&	reserveOutput() throw();
		/** */
		Bits::InOutApi&		reserveInOut() throw();

	public:	// OpenDrainOutputApi
		/** */
		Bits::OutputApi&	reserveOpenDrainOutput() throw();
		/** */
		Bits::InOutApi&		reserveOpenDrainInOut() throw();

	public:	// BRGO::BRGO1Api
		/** */
		Bits::InputApi&	reserveBRGO1() throw();

	public:	// I2C::SDAApi
		/** */
		Bits::InputApi&	reserveI2CSDA() throw();

	private:
		/** */
		void	reserve() throw();
	};

}
}
}


#endif
