/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc860_portc_pc15h_
#define _oscl_drv_mot_mpc860_portc_pc15h_
#include "pc15api.h"
#include "oscl/bits/port.h"
#include "oscl/bits/iobit.h"
#include "oscl/hw/motorola/mpc8xx/portreg.h"

/** */
namespace Oscl{
/** */
namespace Mot860{
/** */
namespace PortC {

/** */
class PC15 : public PC15Api {
	private:
		/** */
		enum{_bitNum=((sizeof(Mot8xx::Port::PCDAT::Reg)*8)-1-15)};
		/** */
		enum{_mask=(1<<_bitNum)};
		/** */
		Bits::IoBit<Mot8xx::Port::PCDAT::Reg,_bitNum,true>	_pcdat;
		/** */
		Bits::IoBit<Mot8xx::Port::PCDIR::Reg,_bitNum,true>	_pcdir;
		/** */
		Bits::IoBit<Mot8xx::Port::PCPAR::Reg,_bitNum,true>	_pcpar;
		/** */
		Bits::IoBit<Mot8xx::Port::PCSO::Reg,_bitNum,true>	_pcso;
		/** */
		Bits::FieldApi<Mot8xx::Port::PCDAT::Reg>&			_reservation;
	public:
		/** */
		PC15(	Bits::FieldApi<Mot8xx::Port::PCDAT::Reg>&	pcdat,
				Bits::FieldApi<Mot8xx::Port::PCDIR::Reg>&	pcdir,
				Bits::FieldApi<Mot8xx::Port::PCPAR::Reg>&	pcpar,
				Bits::FieldApi<Mot8xx::Port::PCSO::Reg>&	pcso,
				Bits::FieldApi<Mot8xx::Port::PCDAT::Reg>&	reservation
				) throw();

	public: // Mpc8xx::IoReserve::IOApi
		/** */
		Bits::InputApi&		reserveInput() throw();
		/** */
		Bits::OutputApi&	reserveOutput() throw();
		/** */
		Bits::InOutApi&		reserveInOut() throw();

	public:	// DMA::REQ0Api
		/** */
		Bits::InputApi&	reserveDREQ0() throw();

	public:	// SCC1::RTSApi
		/** */
		Bits::InputApi&	reserveRTS1() throw();

	public:	// L1::ST1Api
		/** */
		Bits::InputApi&	reserveL1ST1() throw();

	private:
		/** */
		void	reserve() throw();
	};

}
}
}


#endif
