/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc860_portc_pc5apih_
#define _oscl_drv_mot_mpc860_portc_pc5apih_
#include "oscl/driver/motorola/mpc8xx/ioreserve/io.h"
#include "oscl/driver/motorola/mpc8xx/ioreserve/scc4/cts.h"
#include "oscl/driver/motorola/mpc8xx/ioreserve/l1a/tsync.h"
#include "oscl/driver/motorola/mpc8xx/ioreserve/dma/ack1.h"

/** */
namespace Oscl{
/** */
namespace Mot860{
/** */
namespace PortC {

/** */
class PC5Api :
	public Mpc8xx::IoReserve::IOApi,
	public Mpc8xx::IoReserve::SCC4::CTSApi,
	public Mpc8xx::IoReserve::L1A::TSYNCApi,
	public Mpc8xx::IoReserve::DMA::ACK1Api
	{
	public: // IOApi
		/** */
		virtual Bits::InputApi&		reserveInput() throw()=0;
		/** */
		virtual Bits::OutputApi&	reserveOutput() throw()=0;
		/** */
		virtual Bits::InOutApi&		reserveInOut() throw()=0;

	public:	// SCC4::CTSApi
		/** */
		virtual Bits::InputApi&	reserveCTS4() throw()=0;

	public:	// L1A::TSYNCApi
		/** */
		virtual Bits::InputApi&	reserveL1TSYNCA() throw()=0;

	public:	// DMA::ACK1Api
		/** */
		virtual Bits::InputApi&	reserveSDACK1() throw()=0;

	};

}
}
}

#endif
