/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc860_si_cr_scc1h_
#define _oscl_drv_mot_mpc860_si_cr_scc1h_
#include "scc1api.h"
#include "oscl/driver/motorola/mpc8xx/si/cr/gr.h"
#include "oscl/driver/motorola/mpc8xx/si/cr/sc.h"
#include "cs12.h"

/** */
namespace Oscl {
/** */
namespace Mot860 {
/** */
namespace SI {
/** */
namespace CR {

/** */
class SCC1 : public SCC1Api {
	private:
		/** */
		Oscl::Mot8xx::SI::CR::GR<	Oscl::Mot8xx::Si::SICR::Reg,
									Oscl::Mot8xx::Si::SICR::SCC1::GR::Lsb
			>			_gr;
		/** */
		Oscl::Mot8xx::SI::CR::SC<	Oscl::Mot8xx::Si::SICR::Reg,
									Oscl::Mot8xx::Si::SICR::SCC1::SC::Lsb
			>			_sc;
		/** */
		CS12<	Oscl::Mot8xx::Si::SICR::Reg,
				Oscl::Mot8xx::Si::SICR::SCC1::TCS::Lsb
				>		_txcs;
		/** */
		CS12<	Oscl::Mot8xx::Si::SICR::Reg,
				Oscl::Mot8xx::Si::SICR::SCC1::RCS::Lsb
				>		_rxcs;

	public:
		/** */
		SCC1(Oscl::Bits::FieldApi<Oscl::Mot8xx::Si::SICR::Reg>& sicr) throw();

	public:
		/** */
		Oscl::Mot8xx::SI::CR::GRApi&	getGR() throw();
		/** */
		Oscl::Mot8xx::SI::CR::SCApi&	getSC() throw();
		/** */
		Oscl::Mot860::SI::CR::CS12Api&	getTCS() throw();
		/** */
		Oscl::Mot860::SI::CR::CS12Api&	getRCS() throw();
	};

}
}
}
}


#endif
