/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _drv_motorola_mpc8xx_mmu_l2tableh_
#define _drv_motorola_mpc8xx_mmu_l2tableh_
#include "oscl/hw/motorola/mpc8xx/mmu/desc.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Mmu {

/** */
class Level2Descriptor {
	private:
		/** */
		Level2Desc::Reg		_desc;
	public:
		/** */
		Level2Descriptor() throw();
		/** */
		void	setRealPage(void* realPage) throw();
		/** */
		unsigned long	getRealPage() throw();
		/** */
		void	setProtectionNoAccess() throw();
		/** */
		void	setProtectionSuperReadOnly() throw();
		/** */
		void	setProtectionSuperReadWriteOnly() throw();
		/** */
		void	setProtectionSuperReadWriteUserReadOnly() throw();
		/** */
		void	setProtectionAllReadWrite() throw();
		/** */
		void	setProtectionAllReadOnly() throw();
		/** */
		void	setChanged() throw();
		/** */
		void	setUnchanged() throw();
		/** */
		bool	isChanged() throw();
		/** */
		void	set4KPageSize() throw();
		/** */
		void	set16KPageSize() throw();
		/** */
		unsigned long	getPageSizeMask() throw();
		/** */
		void	setSharedPage() throw();
		/** */
		void	setUnsharedPage() throw();
		/** */
		bool	isShared() throw();
		/** */
		void	setCacheInhibit() throw();
		/** */
		void	setCacheAllow() throw();
		/** */
		bool	cacheInhibited() throw();
		/** */
		void	setPageValid() throw();
		/** */
		void	setPageInvalid() throw();
		/** */
		bool	isValid() throw();
	};

/** */
class Level2Table {
	private:
		/** */
		Level2Descriptor	_table[nEntriesInLevel2Table];
	public:
		/** */
		Level2Table() throw();
		/** */
		Level2Descriptor* getDesc(unsigned entry) throw();
		/** */
		Level2Descriptor* getDescTwam1(void* virtAddr) throw();
	};

}
}
}

#endif
