/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_driver_motorola_mpc8xx_pit_delay_serverh_
#define _oscl_driver_motorola_mpc8xx_pit_delay_serverh_
#include "oscl/mt/itc/delay/service/service.h"
#include "oscl/mt/itc/mbox/server.h"
#include "oscl/driver/motorola/mpc8xx/pit/api.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace PIT {
/** */
namespace Delay {

/** */
class Server :	public Oscl::Mt::Itc::Server,
				public Oscl::Mot8xx::PIT::Observer
				{
	private:
		/** */
		Oscl::Mt::Itc::Delay::Service				_delayService;
		/** */
		Oscl::Mt::Itc::Delay::Req::Api::ConcreteSAP	_sap;
		/** */
		unsigned long								_ticksPerMillisecond;
		/** */
		unsigned long								_millisecondsPerTock;
		/** */
		unsigned 									_tickCount;

	public:
		/** */
		Server(unsigned long pitTickFreqInHz) throw();

		/** */
		Oscl::Mt::Itc::Delay::Req::Api::SAP&	getSAP();

	private:	// Oscl::Mt::Itc::Server
		/** */
		void	mboxSignaled() throw();

	private:	// Oscl::Mot8xx::PIT::Observer
		/** This operation is called every PIT
			period.
		 */
		void	tick() throw();
	};

}
}
}
}

#endif
