/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc8xx_si_cr_sch_
#define _oscl_drv_mot_mpc8xx_si_cr_sch_
#include "scapi.h"
#include "oscl/bits/fieldapi.h"
#include "oscl/hw/motorola/mpc8xx/sireg.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace SI {
/** */
namespace CR {

/** */
template <class Type, unsigned Lsb>
class SC : public SCApi {
	private:
		/** */
		Oscl::Bits::FieldApi<Type>&		_sicr;
	public:
		/** */
		SC(Oscl::Bits::FieldApi<Type>& sicr) throw();

	public:	// SCApi
		/** */
		void	selectTSA() throw();
		/** */
		void	selectNMSI() throw();
	};

template <class Type,unsigned Lsb>
SC<Type,Lsb> ::SC(Oscl::Bits::FieldApi<Type>& sicr) throw():
		_sicr(sicr)
		{
	}

template <class Type,unsigned Lsb>
void	SC<Type,Lsb> ::selectTSA() throw(){
	_sicr.changeBits((0x1<<Lsb),1<<Lsb);
	}

template <class Type,unsigned Lsb>
void	SC<Type,Lsb> ::selectNMSI() throw(){
	_sicr.changeBits((0x1<<Lsb),0<<Lsb);
	}

}
}
}
}


#endif
