/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_mpc8xx_si_mr_tdmapih_
#define _oscl_drv_mot_mpc8xx_si_mr_tdmapih_
#include "sdmapi.h"
#include "rfsdapi.h"
#include "dscapi.h"
#include "crtapi.h"
#include "stzapi.h"
#include "ceapi.h"
#include "feapi.h"
#include "gmapi.h"
#include "tfsdapi.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace SI {
/** */
namespace MR {

/** */
class TDMApi {
	public:	// TDMApi
		/** */
		virtual SDMApi&	getSDM() throw()=0;
		/** */
		virtual RFSDApi&	getRFSD() throw()=0;
		/** */
		virtual DSCApi&		getDSC() throw()=0;
		/** */
		virtual CRTApi&		getCRT() throw()=0;
		/** */
		virtual STZApi&		getSTZ() throw()=0;
		/** */
		virtual CEApi&		getCE() throw()=0;
		/** */
		virtual FEApi&		getFE() throw()=0;
		/** */
		virtual GMApi&		getGM() throw()=0;
		/** */
		virtual TFSDApi&	getTFSD() throw()=0;
	};

}
}
}
}

#endif
