/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_quicc_brgc_extch_
#define _oscl_drv_mot_quicc_brgc_extch_
#include "extcapi.h"
#include "oscl/bits/fieldapi.h"
#include "oscl/hw/motorola/quicc/brgcreg.h"

/** */
namespace Oscl {
/** */
namespace Motorola {
/** */
namespace Quicc {
/** */
namespace Brgc {

/** */
class EXTC : public EXTCApi {
	private:
		/** */
		Oscl::Bits::FieldApi<Oscl::Motorola::Quicc::BRGC::Reg>& _brgc;

	public:
		/** */
		EXTC(	Oscl::Bits::FieldApi<Oscl::Motorola::Quicc::BRGC::Reg>& brgc
				) throw();

	public:
		/** */
		void	selectBRGCLK() throw();
		/** */
		void	selectCLK2() throw();
		/** */
		void	selectCLK6() throw();
	};

}
}
}
}

#endif
