/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "driver.h"

using namespace Oscl::Motorola::Quicc::Sdma::Frame::Tx;

Driver::Driver(Oscl::Motorola::Quicc::Sdma::Tx::Api& driver) throw():
		_driver(driver)
		{
	}

void	Driver::initialize() throw(){
	_driver.initialize();
	}

void	Driver::processCompletedBuffers() throw(){
	_driver.processDescriptors();
	}

unsigned	Driver::maxBuffersInFrame() throw(){
	return _driver.nDescriptors();
	}

bool	Driver::resourcesAvailable(unsigned nBuffers) throw(){
	if(nBuffers > _driver.nDescriptors()) return false;
	return _driver.nAvailableDescs() >= nBuffers;
	}

bool	Driver::open() throw(){
	return _driver.openBlock();
	}

bool	Driver::append(const void* buffer,unsigned count) throw(){
	return _driver.appendBufferToBlock((Octet*)buffer,count);
	}

void	Driver::close(Oscl::Done::Api& callback) throw(){
	_driver.closeBlock(callback);
	}

void	Driver::cancel() throw(){
	_driver.cancelBlock();
	}

