/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_mot_quicc_sdma_serial_tx_driverh_
#define _oscl_drv_mot_quicc_sdma_serial_tx_driverh_
#include "oscl/driver/motorola/quicc/sdma/tx/api.h"
#include "oscl/serial/driver/tx/api.h"
#include "oscl/done/api.h"
#include "oscl/queue/queueitem.h"

/** */
namespace Oscl{
/** */
namespace Motorola {
/** */
namespace Quicc {
/** */
namespace Sdma {
/** */
namespace Serial {
/** */
namespace Tx {

/** */
class Driver : public Oscl::Serial::Driver::TX::Api {
	private:
		/** */
		Oscl::Motorola::Quicc::Sdma::Tx::Api&	_driver;

	public:
		/** */
		Driver(Oscl::Motorola::Quicc::Sdma::Tx::Api& driver) throw();

		/** */
		void	initialize() throw();

	private:	// Oscl::Serial::Driver::TX::Api
		/** */
		bool		sendBuffer(	Oscl::Done::Api&	complete,
								const void*			buffer,
								unsigned			length
								) throw();

		/** */
		void		processTransmitter() throw();
	};

}
}
}
}
}
}
#endif
