/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_pci_subclassh_
#define _oscl_drv_pci_subclassh_

/** */
namespace Oscl {
/** */
namespace Pci {
/** */
namespace Config {

/** */
namespace MassStorageController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	scsi() throw()=0;
			/** */
			virtual void	ide() throw()=0;
			/** */
			virtual void	floppy() throw()=0;
			/** */
			virtual void	ipi() throw()=0;
			/** */
			virtual void	raid() throw()=0;
		};
	}

/** */
namespace NetworkController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	ethernet() throw()=0;
			/** */
			virtual void	tokenRing() throw()=0;
			/** */
			virtual void	fddi() throw()=0;
			/** */
			virtual void	atm() throw()=0;
			/** */
			virtual void	isdn() throw()=0;
		};
	}

/** */
namespace DisplayController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	vga() throw()=0;
			/** */
			virtual void	xga() throw()=0;
			/** */
			virtual void	threeD() throw()=0;
		};
	}

/** */
namespace MultimediaDevice {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	video() throw()=0;
			/** */
			virtual void	audio() throw()=0;
			/** */
			virtual void	computerTelephony() throw()=0;
		};
	}

/** */
namespace MemoryController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	ram() throw()=0;
			/** */
			virtual void	flash() throw()=0;
		};
	}

/** */
namespace BridgeDevice {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	hostPci() throw()=0;
			/** */
			virtual void	pciIsa() throw()=0;
			/** */
			virtual void	pciEisa() throw()=0;
			/** */
			virtual void	pciMicroChannel() throw()=0;
			/** */
			virtual void	pciPci() throw()=0;
			/** */
			virtual void	pciPcmcia() throw()=0;
			/** */
			virtual void	pciNuBus() throw()=0;
			/** */
			virtual void	pciCardBus() throw()=0;
			/** */
			virtual void	pciRaceway() throw()=0;
		};
	}

/** */
namespace SimpleCommController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	serial() throw()=0;
			/** */
			virtual void	parallel() throw()=0;
			/** */
			virtual void	multiportSerial() throw()=0;
			/** */
			virtual void	modem() throw()=0;
		};
	}

/** */
namespace BaseSystemPeripheral {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	pic() throw()=0;
			/** */
			virtual void	dma() throw()=0;
			/** */
			virtual void	timer() throw()=0;
			/** */
			virtual void	timer() throw()=0;
			/** */
			virtual void	rtc() throw()=0;
			/** */
			virtual void	pciHotPlug() throw()=0;
		};
	}

/** */
namespace InputDevice {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	keyboard() throw()=0;
			/** */
			virtual void	digitizer() throw()=0;
			/** */
			virtual void	mouse() throw()=0;
			/** */
			virtual void	scanner() throw()=0;
			/** */
			virtual void	gameport() throw()=0;
		};
	}

/** */
namespace DockingStation {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	generic() throw()=0;
		};
	}

/** */
namespace Processor {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	i386() throw()=0;
			/** */
			virtual void	i486() throw()=0;
			/** */
			virtual void	pentium() throw()=0;
			/** */
			virtual void	alpha() throw()=0;
			/** */
			virtual void	powerPC() throw()=0;
			/** */
			virtual void	mips() throw()=0;
			/** */
			virtual void	coProcessor() throw()=0;
		};
	}

/** */
namespace SerialBusController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	firewire() throw()=0;
			/** */
			virtual void	accessBus() throw()=0;
			/** */
			virtual void	ssa() throw()=0;
			/** */
			virtual void	usb() throw()=0;
			/** */
			virtual void	fibreChannel() throw()=0;
			/** */
			virtual void	smbus() throw()=0;
		};
	}

/** */
namespace WirelessController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	irda() throw()=0;
			/** */
			virtual void	consumerIR() throw()=0;
			/** */
			virtual void	rf() throw()=0;
		};
	}

/** */
namespace IntelligentIoController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	unknown() throw()=0;
		};
	}

/** */
namespace SatelliteCommControler {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	tv() throw()=0;
			/** */
			virtual void	audio() throw()=0;
			/** */
			virtual void	voice() throw()=0;
			/** */
			virtual void	data() throw()=0;
		};
	}

/** */
namespace EncryptionController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	networkComputing() throw()=0;
			/** */
			virtual void	entertainment() throw()=0;
		};
	}

/** */
namespace DataAcquisitionDspController {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	dpio() throw()=0;
		};
	}

/** */
namespace DoesNotFitDefinedClassCode {
	/** */
	class VisitorApi {
		public:
			/** */
			virtual void	unknown() throw()=0;
		};
	}
}
}
}

#endif
