/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "oscl/kernel/map.h"
#include "oscl/hw/sim68k/map.h"

void OsclKernelMemoryMapInit() throw(){
	// This function is called during system initialization
	// when interrupts are still disabled. The idea is to
	// place the system in a state in which all devices
	// have their interrupts masked. This is useful with
	// devices which generate interrupts upon being
	// comming out of reset and are not currently used by
	// the software in the system. These devices can be quieted
	// here without the need to write drivers for the hardware.

	SiemensSAB82526.write.MASK		= (Oscl::Flags)0xFF;	// Disable all interrupts
	SiemensSAB82525[0].write.MASK	= (Oscl::Flags)0xFF;	// Disable all interrupts
	SiemensSAB82525[1].write.MASK	= (Oscl::Flags)0xFF;	// Disable all interrupts
	}
