/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_driver_tundra_qspan_interrupt_apih_
#define _oscl_driver_tundra_qspan_interrupt_apih_
#include "stat.h"
#include "oscl/interrupt/handler.h"

/** */
namespace Oscl {
/** */
namespace Tundra {
/** */
namespace Qspan {
/** */
namespace Irq {

/** */
class Api {
	public:
		/** */
		virtual ~Api() {}
		/** */
		virtual void	reservePciBusErrorLog(	Oscl::Interrupt::
												HandlerApi&		handler
												) throw()=0;
		/** */
		virtual void	releasePciBusErrorLog() throw()=0;
		/** */
		virtual void	reserveQBusErrorLog(	Oscl::Interrupt::
												HandlerApi&		handler
												) throw()=0;
		/** */
		virtual void	releaseQBusErrorLog() throw()=0;
		/** */
		virtual void	reserveDataParity(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releaseDataParity() throw()=0;
		/** */
		virtual void	reserveIdmaQBusError(	Oscl::Interrupt::
												HandlerApi&		handler
												) throw()=0;
		/** */
		virtual void	releaseIdmaQBusError() throw()=0;
		/** */
		virtual void	reserveIdmaPciError(	Oscl::Interrupt::
												HandlerApi&		handler
												) throw()=0;
		/** */
		virtual void	releaseIdmaPciError() throw()=0;
		/** */
		virtual void	reserveIdmaReset(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releaseIdmaReset() throw()=0;
		/** */
		virtual void	reserveIdmaDone(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releaseIdmaDone() throw()=0;
		/** */
		virtual void	reservePciInt(	Oscl::Interrupt::
										HandlerApi&		handler
										) throw()=0;
		/** */
		virtual void	releasePciInt() throw()=0;
		/** */
		virtual void	reservePciBusPerr(	Oscl::Interrupt::
										HandlerApi&		handler
										) throw()=0;
		/** */
		virtual void	releasePciBusPerr() throw()=0;
		/** */
		virtual void	reservePciBusSerr(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releasePciBusSerr() throw()=0;
		/** */
		virtual void	reserveQBusInt(	Oscl::Interrupt::
										HandlerApi&		handler
										) throw()=0;
		/** */
		virtual void	releaseQBusInt() throw()=0;
		/** */
		virtual void	reserveSoftware3(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releaseSoftware3() throw()=0;
		/** */
		virtual void	reserveSoftware2(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releaseSoftware2() throw()=0;
		/** */
		virtual void	reserveSoftware1(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releaseSoftware1() throw()=0;
		/** */
		virtual void	reserveSoftware0(	Oscl::Interrupt::
											HandlerApi&		handler
											) throw()=0;
		/** */
		virtual void	releaseSoftware0() throw()=0;
	};

}
}
}
}

#endif
