/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_driver_tundra_qspan_interrupt_sourceh_
#define _oscl_driver_tundra_qspan_interrupt_sourceh_
#include "ctrl.h"
#include "oscl/interrupt/shared/source.h"
#include "oscl/interrupt/handler.h"

/** */
namespace Oscl {
/** */
namespace Tundra {
/** */
namespace Qspan {
/** */
namespace Irq {

/** */
class PciIntSource :
		public Oscl::Interrupt::HandlerApi,
		private Oscl::Interrupt::Shared::ListStateMonitorApi
		{
	private:
		/** */
		Oscl::Interrupt::Shared::Source	_source;
		/** */
		ControlDriver&					_ctrlDrv;
	public:
		/** */
		PciIntSource(ControlDriver& ctrlDrv) throw();
		/** */
		Oscl::Interrupt::Shared::SourceApi&	getSourceApi() throw();

	private:	// Oscl::Interrupt::Shared::ListStateMonitorApi
		/** */
		void	listIsNowEmpty() throw();
		/** */
		void	listIsNowNotEmpty() throw();
		/** */
		void	interrupt() throw();
	};

}
}
}
}

#endif
