/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_usb_hcd_enum_dcp_varh_
#define _oscl_drv_usb_hcd_enum_dcp_varh_
#include "api.h"

#include "oscl/driver/usb/alloc/pipe/message/sync.h"
#include "oscl/driver/usb/pipe/message/sync.h"

/** */
namespace Oscl {
/** */
namespace Usb {
/** */
namespace HCD {
/** */
namespace Enum {
/** */
namespace DefCntrlPipe {

/** HCD interfaces required by a device enumeration monitor. */
class Var : public Api {
	public:
		/** */
		Oscl::Usb::Alloc::
		Pipe::Message::
		Req::Api::ConcreteSAP				_msgPipeAllocSAP;
		/** */
		Oscl::Usb::Alloc::
		Pipe::Message::
		Sync								_msgPipeAllocSync;
		/** */
		Oscl::Usb::Alloc::
		Addr::Req::Api::ConcreteSAP			_hubPortSAP;
		/** */
		Oscl::Usb::Pipe::
		Message::PipeApi&					_lsPipeApi;
		/** */
		Oscl::Usb::Pipe::
		Message::PipeApi&					_hsPipeApi;
	public:
		/** */
		Var(	Oscl::Mt::Itc::PostMsgApi&	myPapi,
				Oscl::Usb::Alloc::
				Pipe::Message::
				Req::Api&					msgPipeAllocReqApi,
				Oscl::Usb::Alloc::
				Addr::Req::Api&				hubPortReqApi,
				Oscl::Usb::Pipe::
				Message::PipeApi&			lsPipeApi,
				Oscl::Usb::Pipe::
				Message::PipeApi&			hsPipeApi
				) throw();
	public:	// Api
		/** */
		Oscl::Usb::Alloc::
		Pipe::Message::
		Req::Api::SAP&				getMsgPipeAllocSAP() throw();
		/** */
		Oscl::Usb::Alloc::
		Pipe::Message::
		SyncApi&					getMsgPipeAllocSyncApi() throw();
		/** */
		Oscl::Usb::Alloc::
		Addr::Req::Api::SAP&		getHubPortSAP() throw();
		/** */
		Oscl::Usb::Pipe::
		Message::PipeApi&			getLsPipeApi() throw();
		/** */
		Oscl::Usb::Pipe::
		Message::PipeApi&			getHsPipeApi() throw();
	};

}
}
}
}
}

#endif
