/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_usb_ohci_device_rhrespapih_
#define _oscl_drv_usb_ohci_device_rhrespapih_
#include "rhreqapi.h"
#include "oscl/mt/itc/mbox/clievt.h"

/** */
namespace Oscl {
/** */
namespace Usb {
/** */
namespace Ohci {
/** */
namespace HCD {
/** */
namespace RootHub {
/** */
namespace Resp {

/** */
class Api {
	public:	// Requests
		/** */
		typedef Oscl::Mt::Itc::
				CliEvent<	Req::Api,
							Api,
							Req::Api::OpenPayload
							>			OpenResp;
		/** */
		typedef Oscl::Mt::Itc::
				CliEvent<	Req::Api,
							Api,
							Req::Api::ClosePayload
							>			CloseResp;
		/** */
		typedef Oscl::Mt::Itc::
				CliEvent<	Req::Api,
							Resp::Api,
							Req::Api::StatusChangePayload
							>			ChangeResp;
		/** */
		typedef Oscl::Mt::Itc::
				CliEvent<	Req::Api,
							Api,
							Req::Api::CancelAllPayload
							>			CancelAllResp;
	public:
		/** */
		virtual void	response(OpenResp& msg) throw()=0;
		/** */
		virtual void	response(CloseResp& msg) throw()=0;
		/** */
		virtual void	response(ChangeResp& msg) throw()=0;
		/** */
		virtual void	response(CancelAllResp& msg) throw()=0;
	};

}
}
}
}
}
}


#endif
