/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "bulkinpipe.h"

using namespace Oscl::Usb::Ohci::HCD;

BulkInPipe::
BulkInPipe(	Oscl::Mt::Itc::PostMsgApi&			myPapi,
			Oscl::Usb::Ohci::ED::GeneralIn&		ed,
			Oscl::Usb::Ohci::HCD::HcdApi&		hcdContext
			) throw():
		_driver(myPapi,ed,hcdContext)
		{
	}

Oscl::Mt::Itc::Srv::
Close::Req::Api::SAP&		BulkInPipe::getCloseSAP() throw(){
	return _driver.getCloseSAP();
	}

Oscl::Mt::Itc::Srv::
OpenCloseSyncApi&			BulkInPipe::getOpenCloseSyncApi() throw(){
	return _driver.getOpenCloseSyncApi();
	}

Oscl::Usb::Pipe::Bulk::IN::
Req::Api::SAP&	BulkInPipe::getSAP() throw(){
	return _driver.getSAP();
	}

Oscl::Usb::Ohci::ED::GeneralIn&			BulkInPipe::getED() throw(){
	return _driver.getED();
	}

/////////// BulkInPipeRec /////////

BulkInPipeRec::
BulkInPipeRec(	Oscl::Mt::Itc::PostMsgApi&			myPapi,
					Oscl::Usb::Ohci::ED::GeneralIn&		ed,
					Oscl::Usb::Ohci::HCD::HcdApi&		hcdContext
					) throw():
		_pipe(myPapi,ed,hcdContext)
		{
	}

