/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_drv_usb_ohci_hcd_server_msgpipeh_
#define _oscl_drv_usb_ohci_hcd_server_msgpipeh_
#include "oscl/driver/usb/pipe/message/sync.h"
#include "oscl/driver/usb/pipe/message/pipeapi.h"
#include "oscl/driver/usb/ohci/hcd/pipe/message/driver.h"

/** */
namespace Oscl {
/** */
namespace Usb {
/** */
namespace Ohci {
/** */
namespace HCD {

/** */
class MessagePipe : public Oscl::Usb::Pipe::Message::PipeApi {
	private:
		/** */
		Oscl::Usb::Ohci::HCD::Pipe::Message::Driver	_driver;
		/** */
		Oscl::Usb::Pipe::Message::Sync				_sync;
	public:
		/** */
		MessagePipe(	Oscl::Mt::Itc::PostMsgApi&			myPapi,
						Oscl::Usb::Ohci::ED::Message&		ed,
						Oscl::Usb::Ohci::HCD::HcdApi&		hcdContext
						) throw();
		/** */
		Oscl::Usb::Ohci::ED::Message&			getED() throw();

	public:	// Oscl::Usb::Pipe::Message::PipeApi
        /** */
		Oscl::Mt::Itc::Srv::
		Close::Req::Api::SAP&			getCloseSAP() throw();
        /** */
		Oscl::Mt::Itc::Srv::
		OpenCloseSyncApi&				getOpenCloseSyncApi() throw();
		/** */
		Oscl::Usb::Pipe::Message::
		Req::Api::SAP&					getSAP() throw();
		/** */
		Oscl::Usb::Pipe::Message::
		SyncApi&						getSyncApi() throw();
	};

/** */
class MessagePipeRec : public Oscl::QueueItem {
	public:
		/** */
		MessagePipe		_pipe;
	public:
		/** */
		MessagePipeRec(	Oscl::Mt::Itc::PostMsgApi&			myPapi,
						Oscl::Usb::Ohci::ED::Message&		ed,
						Oscl::Usb::Ohci::HCD::HcdApi&		hcdContext
						) throw();
	};

}
}
}
}

#endif
