/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_fs_dir_wo_itc_synch_
#define _oscl_fs_dir_wo_itc_synch_
#include "oscl/fs/dir/wo/api.h"
#include "reqapi.h"

/** */
namespace Oscl {
/** */
namespace FS {
/** */
namespace Dir {
/** */
namespace WO {
/** */
namespace ITC {

/** */
class Sync : public Oscl::FS::Dir::WO::Api {
	private:
		/** */
		Req::Api::ConcreteSAP	_sap;

	public:
		/** */
		Sync(	Req::Api&					reqApi,
				Oscl::Mt::Itc::PostMsgApi&	myPapi
				) throw();
		/** */
		Req::Api::SAP&	getSAP() throw();

	public:	// Oscl::FS::Dir::WO::Api
		/** */
		const Move::Status::Result*
			move(	const Oscl::ObjectID::RO::Api&	volume,
					const char*						srcPath,
					const char*						destPath
					) throw();
		/** */
		const Copy::Status::Result*
			copy(	const Oscl::ObjectID::RO::Api&	srcVolume,
					const char*						srcPath,
					const Oscl::ObjectID::RO::Api&	destVolume,
					const char*						destPath
					) throw();
		/** */
		const Create::Status::Result*
			createFile(	const Oscl::ObjectID::RO::Api&	volume,
						const char*						path
						) throw();
		/** */
		const Create::Status::Result*
			createDir(	const Oscl::ObjectID::RO::Api&	volume,
						const char*						path
						) throw();
		/** */
		const Remove::Status::Result*
			remove(	const Oscl::ObjectID::RO::Api&	volume,
					const char*						path
					) throw();
	};

}
}
}
}
}

#endif
