/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_fs_dir_wo_statush_
#define _oscl_fs_dir_wo_statush_

/** */
namespace Oscl {
/** */
namespace FS {
/** */
namespace Dir {
/** */
namespace WO {

/** */
namespace Move {
/** */
namespace Status {
/** */
class Result;
/** */
const Result&	getNoSuchVolume() throw();
/** */
const Result&	getNoSuchSrcPath() throw();
/** */
const Result&	getInvalidDestPath() throw();
/** */
const Result&	getDestDirectoryFull() throw();
/** */
const Result&	getSrcPathElementBusy() throw();
/** */
const Result&	getOutOfSpace() throw();
/** */
const Result&	getTransportError() throw();

}
}

/** */
namespace Copy {
/** */
namespace Status {
/** */
class Result;
/** */
const Result&	getNoSuchSrcVolume() throw();
/** */
const Result&	getNoSuchDestVolume() throw();
/** */
const Result&	getNoSuchSrcPath() throw();
/** */
const Result&	getInvalidDestPath() throw();
/** */
const Result&	getDestDirectoryFull() throw();
/** */
const Result&	getDestOutOfSpace() throw();
/** */
const Result&	getSrcTransportError() throw();
/** */
const Result&	getDestTransportError() throw();
}
}

/** */
namespace Create {
/** */
namespace Status {
/** */
class Result;
/** */
const Result&	getNoSuchVolume() throw();
/** */
const Result&	getInvalidPath() throw();
/** */
const Result&	getPathAlreadyExists() throw();
/** */
const Result&	getOtherTypePathExists() throw();
/** */
const Result&	getDirectoryFull() throw();
/** */
const Result&	getOutOfSpace() throw();
/** */
const Result&	getTransportError() throw();
}
}

/** */
namespace Remove {
/** */
namespace Status {
/** */
class Result;
/** */
const Result&	getNoSuchVolume() throw();
/** */
const Result&	getNoSuchPath() throw();
/** */
const Result&	getTransportError() throw();
}
}


}
}
}
}

#endif
