/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include <new>
#include "match.h"

using namespace Oscl::FS::Volume::Mounter;

Match::Match(const Oscl::ObjectID::RO::Api*	specificLocation) throw():
		_specificLocation(specificLocation)
		{
	}

Match::Match(const Oscl::ObjectID::RO::Api&	specificLocation) throw():
		_specificLocation(&specificLocation)
		{
	}

bool	Match::next(Oscl::Block::RW::Dyn::Service& device) throw(){
	if(device.isReserved()) return false;
	switch(device.type()){
		case Oscl::Block::RW::Dyn::Service::fat:
		case Oscl::Block::RW::Dyn::Service::lbaFat:
			break;
		case Oscl::Block::RW::Dyn::Service::raw:
		case Oscl::Block::RW::Dyn::Service::lbaExtended:
		case Oscl::Block::RW::Dyn::Service::extended:
		default:
			return false;
		}
	if(_specificLocation){
		if(*_specificLocation != device._location) return false;
		}
	device.lock();
	if(device.isReserved()){
		device.unlock();
		return false;
		}
	device.reserve();
	device.unlock();
	return true;
	}

