/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "decoder.h"

using namespace Oscl::HDLC::LLC::Proto::RX;

Decoder::Decoder() throw()
		{
	}

Oscl::PDU::Api* Decoder::forward(Oscl::PDU::Api& frame) throw(){
	unsigned		length;
	unsigned		protocol;
	unsigned char	buffer[protocolFieldLength];

	length	= frame.copyOut(buffer,protocolFieldLength);

	protocol	=	buffer[0];
	protocol	<<=	8;
	protocol	|=	buffer[1];

	Oscl::HDLC::LLC::Proto::RX::Entry*	entry;

	for(	entry	= _protocols.first();
			entry;
			entry	= _protocols.next(entry)
			){
		if(entry->match(protocol)){
			frame.stripHeader(protocolFieldLength);
			entry->forward(frame);
			return 0;
			}
		}

	frame.free();
	return 0;
	}

void	Decoder::attach(	Oscl::HDLC::LLC::
							Proto::RX::Entry&		entry
							) throw(){
	_protocols.put(&entry);
	}

void	Decoder::detach(	Oscl::HDLC::LLC::
							Proto::RX::Entry&		entry
							) throw(){
	_protocols.remove(&entry);
	}

