/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_est_mdp8xx_maph_
#define _oscl_hw_est_mdp8xx_maph_
#include "oscl/compiler/types.h"

/** This file declares each hardware device as a
	data structure. The actual declaration is in
	the link.map file which assigns absolute addresses
	at link time.
 */

enum {IntelIxp4xxSdramSize = (64*1024*1024)};
enum {IntelIxp4xxPciBusSize = (128*1024*1024)};
enum {IntelIxp4xxExpansionBusSize = (256*1024*1024)};
enum {IntelIxp4xxQueueManagerSize = (64*1024*1024)};
enum {IntelIxp4xxPciConfigRegSize = (64*1024*1024)};
enum {IntelIxp4xxExpansionConfigRegSize = (64*1024*1024)};
enum {IntelIxp4xxHighSpeedUartSize = (1*1024)};
enum {IntelIxp4xxConsoleUartSize = (1*1024)};
enum {IntelIxp4xxInternalBusPerfMonSize = (1*1024)};
enum {IntelIxp4xxInterruptControllerSize = (1*1024)};
enum {IntelIxp4xxGpioControllerSize = (1*1024)};
enum {IntelIxp4xxTimersSize = (1*1024)};
enum {IntelIxp4xxWanHssNpeSize = (1*1024)};
enum {IntelIxp4xxEnetNpeASize = (1*1024)};
enum {IntelIxp4xxEnetNpeBSize = (1*1024)};
enum {IntelIxp4xxEnetMacASize = (1*1024)};
enum {IntelIxp4xxEnetMacBSize = (1*1024)};
enum {IntelIxp4xxUsbControllerSize = (1*1024)};
enum {IntelIxp4xxSdramConfigSize = (1*1024)};

extern UByte   IntelIxp4xxSDRAM[IntelIxp4xxSdramSize];
extern UByte   IntelIxp4xxPciBus[IntelIxp4xxPciBusSize];
extern UByte   IntelIxp4xxExpansionBus[IntelIxp4xxExpansionBusSize];
extern UByte   IntelIxp4xxQueueManager[IntelIxp4xxQueueManagerSize];
// FIXME: Need register defs
extern UByte   IntelIxp4xxPciConfigReg[IntelIxp4xxQueueManagerSize];
extern UByte   IntelIxp4xxExpansionConfigReg[IntelIxp4xxExpansionConfigRegSize];
extern UByte   IntelIxp4xxHighSpeedUART[IntelIxp4xxHighSpeedUartSize];
extern UByte   IntelIxp4xxConsoleUART[IntelIxp4xxConsoleUartSize];
extern UByte   IntelIxp4xxInternalBusPerfMon[IntelIxp4xxInternalBusPerfMonSize];
extern UByte   IntelIxp4xxInterruptController[IntelIxp4xxInterruptControllerSize];
extern UByte   IntelIxp4xxGpioController[IntelIxp4xxGpioControllerSize];
extern UByte   IntelIxp4xxTimers[IntelIxp4xxTimersSize];
extern UByte   IntelIxp4xxWanHssNpe[IntelIxp4xxWanHssNpeSize];
extern UByte   IntelIxp4xxEnetNpeA[IntelIxp4xxEnetNpeASize];
extern UByte   IntelIxp4xxEnetNpeB[IntelIxp4xxEnetNpeBSize];
extern UByte   IntelIxp4xxEnetMacA[IntelIxp4xxEnetMacASize];
extern UByte   IntelIxp4xxEnetMacB[IntelIxp4xxEnetMacBSize];
extern UByte   IntelIxp4xxUsbController[IntelIxp4xxUsbControllerSize];
extern UByte   IntelIxp4xxSdramConfig[IntelIxp4xxSdramConfigSize];

#endif
