/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_hitachi_h83664_maph_
#define _oscl_hw_hitachi_h83664_maph_
#include "oscl/compiler/types.h"

namespace Oscl{
namespace H83664 {

struct TimerA {
	Oscl::Unsigned8		tma;	// FFA6
	Oscl::Unsigned8		tca;	// FFA7
	};

struct TimerW {
	Oscl::Unsigned8			tmrw;
	Oscl::Unsigned8			tcrw;
	Oscl::Unsigned8			tierw;
	volatile Oscl::Unsigned8	tsrw;
	Oscl::Unsigned8			tior0;
	Oscl::Unsigned8			tior1;
	Oscl::Unsigned16			tcnt;
	Oscl::Unsigned16			gra;
	Oscl::Unsigned16			grb;
	Oscl::Unsigned16			grc;
	Oscl::Unsigned16			grd;
	};

}
}

extern Oscl::H83664::TimerW	H83664_TimerW __attribute__((eightbit_data));
extern Oscl::H83664::TimerA	H83664_TimerA __attribute__((eightbit_data));
extern Oscl::Unsigned8		H83664_PDR5 __attribute__((eightbit_data));
extern Oscl::Unsigned8		H83664_PMR5 __attribute__((eightbit_data));
extern Oscl::Unsigned8		H83664_PCR5 __attribute__((eightbit_data));

extern Oscl::Unsigned8		H83664_PDR8 __attribute__((eightbit_data));
extern Oscl::Unsigned8		H83664_PCR8 __attribute__((eightbit_data));

extern Oscl::Unsigned8		H83664_IRR1 __attribute__((eightbit_data));
extern Oscl::Unsigned8		H83664_IENR1 __attribute__((eightbit_data));

#endif
