/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _hw_mot_mpc8xx_mpc850_immh_
#define _hw_mot_mpc8xx_mpc850_immh_
#include "siu.h"
#include "memc.h"
#include "sitimer.h"
#include "clkrst.h"
#include "sitkey.h"
#include "clkrstkey.h"
#include "dma.h"
#include "cpmic.h"
#include "cpmtimer.h"
#include "cpm.h"
#include "dpram.h"
#include "xdpram.h"
#include "pram.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {

/** */
typedef struct Map {
	Mot8xx::Siu::Map		siu;
	Unsigned8				reserved1[0x100-0x034];
	Mot8xx::Memc::Map		memc;
	Unsigned8				reserved2[0x200-0x180];
	Mot8xx::SiTimer::Map	sitimer;
	Unsigned8				reserved3[0x280-0x24C];
	Mot8xx::ClkRst::Map		clkrst;
	Unsigned8				reserved4[0x300-0x28C];
	Mot8xx::SitKey::Map		sitkey;
	Unsigned8				reserved5[0x380-0x348];
	Mot8xx::ClkRstKey::Map	clkrstkey;
	Unsigned8				reserved6[0x904-0x38C];
	Mot8xx::Dma::Map		dma;
	Unsigned8				reserved7[0x930-0x91D];
	Mot8xx::Cpmic::Map		cpmic;
	Unsigned8				reserved8[0x980-0x950];
	Mot8xx::CpmTimer::Map	cpmtimer;
	Unsigned8				reserved9[0x9C0-0x9B8];
	Mot8xx::Cpm::Map		cpm;
	Unsigned8				reserved10[0x2000-0x9DC];
	Mot8xx::DpRam::Map		dpram;
	Mot8xx::XDpRam::Map		xdpram;
	Mot8xx::Pram::Map		pram;
	} Map;

};
};

#endif
