/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _hw_mot_mpc8xx_mpc850_immh_
#define _hw_mot_mpc8xx_mpc850_immh_
#include "oscl/hw/motorola/mpc8xx/siu.h"
#include "oscl/hw/motorola/mpc8xx/memc.h"
#include "oscl/hw/motorola/mpc8xx/sitimer.h"
#include "oscl/hw/motorola/mpc8xx/clkrst.h"
#include "oscl/hw/motorola/mpc8xx/sitkey.h"
#include "oscl/hw/motorola/mpc8xx/clkrstkey.h"
#include "oscl/hw/motorola/mpc8xx/i2c.h"
#include "oscl/hw/motorola/mpc8xx/dma.h"
#include "oscl/hw/motorola/mpc8xx/cpmic.h"
#include "oscl/hw/motorola/mpc8xx/port.h"
#include "oscl/hw/motorola/mpc8xx/cpmtimer.h"
#include "oscl/hw/motorola/mpc8xx/cpm.h"
#include "oscl/hw/motorola/mpc8xx/brg.h"
#include "oscl/hw/motorola/mpc8xx/usb.h"
#include "oscl/hw/motorola/mpc8xx/scc.h"
#include "oscl/hw/motorola/mpc8xx/sccir.h"
#include "oscl/hw/motorola/mpc8xx/smc.h"
#include "oscl/hw/motorola/mpc8xx/spi.h"
#include "oscl/hw/motorola/mpc8xx/portb.h"
#include "oscl/hw/motorola/mpc8xx/si.h"
#include "oscl/hw/motorola/mpc8xx/siram.h"
#include "oscl/hw/motorola/mpc8xx/dpram.h"
#include "oscl/hw/motorola/mpc8xx/xdpram.h"
#include "oscl/hw/motorola/mpc8xx/pram.h"
#include "pcmcia.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Mpc850 {

/** */
typedef struct Map {
	Mot8xx::Siu::Map		siu;
	Unsigned8				reserved1[0x080-0x034];
	Pcmcia::Map				pcmcia;
	Unsigned8				reserved2[0x100-0x0FC];
	Mot8xx::Memc::Map		memc;
	Unsigned8				reserved3[0x200-0x180];
	Mot8xx::SiTimer::Map	sitimer;
	Unsigned8				reserved4[0x280-0x24C];
	Mot8xx::ClkRst::Map		clkrst;
	Unsigned8				reserved5[0x300-0x28C];
	Mot8xx::SitKey::Map		sitkey;
	Unsigned8				reserved6[0x380-0x348];
	Mot8xx::ClkRstKey::Map	clkrstkey;
	Unsigned8				reserved7[0x860-0x38C];
	Mot8xx::I2C::Map		i2c;
	Unsigned8				reserved8[0x904-0x875];
	Mot8xx::Dma::Map		dma;
	Unsigned8				reserved9[0x930-0x91D];
	Mot8xx::Cpmic::Map		cpmic;
	Mot8xx::Port::Map		port;
	Unsigned8				reserved10[0x980-0x978];
	Mot8xx::CpmTimer::Map	cpmtimer;
	Unsigned8				reserved1x[0x9C0-0x9B8];
	Mot8xx::Cpm::Map		cpm;
	Unsigned8				reserved11[0x9F0-0x9DC];
	Mot8xx::Brg::Map		brg;
	Mot8xx::Usb::Map		usb;
	Unsigned8				reserved12[0xA20-0xA18];
	Mot8xx::SccIr::Map		scc2;
	Mot8xx::Scc::Map		scc3;
	Unsigned8				reserved13[0xA80-0xA61];
	Mot8xx::Smc::Map		smc1;
	Mot8xx::Smc::Map		smc2;
	Mot8xx::Spi::Map		spi;
	Unsigned8				reserved14[0xAB8-0xAB0];
	Mot8xx::PortB::Map		portb;
	Unsigned8				reserved15[0xAE0-0xAC8];
	Mot8xx::Si::Map			si;
	Unsigned8				reserved16[0xC00-0xAF4];
	Mot8xx::SiRam::Map		siram;
	Unsigned8				reserved17[0x2000-0xE00];
	Mot8xx::DpRam::Map		dpram;
	Mot8xx::XDpRam::Map		xdpram;
	Mot8xx::Pram::Map		pram;
	} Map;

};
};
};

#endif
