/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_dsph_
#define _oscl_hw_motorola_mpc8xx_pram_dsph_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {

/** */
typedef struct DSP {
	/** */
	Unsigned32	fdbase;	// User
	/** */
	Unsigned32	fd_ptr;
	/** */
	Unsigned32	dstate;
	/** */
	Unsigned32	reserved;
	/** */
	Unsigned16	dstatus;
	/** */
	Unsigned16	i;
	/** */
	Unsigned16	tap;
	/** */
	Unsigned16	cbase;
	/** */
	Unsigned16	samplesize;
	/** */
	Unsigned16	xptr;
	/** */
	Unsigned16	outputbuffersize;
	/** */
	Unsigned16	yptr;
	/** */
	Unsigned16	m;
	/** */
	Unsigned16	ibdp;
	/** */
	Unsigned16	n;
	/** */
	Unsigned16	obdp;
	/** */
	Unsigned16	k;
	/** */
	Unsigned16	cbdp;
	/** */
	unsigned char	pad[0x40-0x2C];
	} DSP;

}
}
}

#endif
