/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_eneth_
#define _oscl_hw_motorola_mpc8xx_pram_eneth_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"
#include "header.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {
/** */
namespace SCC {

/** */
typedef struct ENET {
	/** */
	Header		header;
	/** */
	Unsigned32	rcrc;
	/** */
	Unsigned32	tcrc;
	/** */
	Unsigned32	c_pres;	// User
	/** */
	Unsigned32	c_mask;	// User
	/** */
	Unsigned32	crcec;	// User
	/** */
	Unsigned32	alec;	// User
	/** */
	Unsigned32	disfc;	// User
	/** */
	Unsigned16	pads;	// User
	/** */
	Unsigned16	ret_lim;	// User
	/** */
	Unsigned16	ret_cnt;
	/** */
	Unsigned16	mflr;	// User
	/** */
	Unsigned16	minflr;	// User
	/** */
	Unsigned16	maxd1;	// User
	/** */
	Unsigned16	maxd2;	// User
	/** */
	Unsigned16	maxd;
	/** */
	Unsigned16	dma_cnt;
	/** */
	Unsigned16	max_b;
	/** */
	Unsigned16	gaddr1;	// User
	/** */
	Unsigned16	gaddr2;	// User
	/** */
	Unsigned16	gaddr3;	// User
	/** */
	Unsigned16	gaddr4;	// User
	/** */
	Unsigned32	tbuf0_data0;
	/** */
	Unsigned32	tbuf0_data1;
	/** */
	Unsigned32	tbuf0_rba0;
	/** */
	Unsigned32	tbuf0_crc;
	/** */
	Unsigned16	tbuf0_bcnt;
	/** */
	Unsigned16	paddr1_h;	// User
	/** */
	Unsigned16	paddr1_m;	// User
	/** */
	Unsigned16	paddr1_l;	// User
	/** */
	Unsigned16	p_per;	// User
	/** */
	Unsigned16	rfbd_ptr;
	/** */
	Unsigned16	tfbd_ptr;
	/** */
	Unsigned16	tlbd_ptr;
	/** */
	Unsigned32	tbuf1_data0;
	/** */
	Unsigned32	tbuf1_data1;
	/** */
	Unsigned32	tbuf1_rba0;
	/** */
	Unsigned32	tbuf1_crc;
	/** */
	Unsigned16	tbuf1_bcnt;
	/** */
	Unsigned16	tx_len;
	/** */
	Unsigned16	iaddr1;	// User
	/** */
	Unsigned16	iaddr2;	// User
	/** */
	Unsigned16	iaddr3;	// User
	/** */
	Unsigned16	iaddr4;	// User
	/** */
	Unsigned16	boff_cnt;
	/** */
	Unsigned16	taddr_h;	// User
	/** */
	Unsigned16	taddr_m;	// User
	/** */
	Unsigned16	taddr_l;	// User
	}ENET;

}
}
}
}

#endif
