/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_hdlch_
#define _oscl_hw_motorola_mpc8xx_pram_hdlch_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"
#include "header.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {
/** */
namespace SCC {

/** */
typedef struct HDLC {
	/** */
	Header		header;
	/** */
	Unsigned32	rcrc;
	/** */
	Unsigned32	tcrc;
	/** */
	Unsigned32	reserved;
	/** */
	Unsigned32	c_mask;	// User
	/** */
	Unsigned32	c_pres;	// User
	/** */
	Unsigned16	disfc;	// User
	/** */
	Unsigned16	crcec;	// User
	/** */
	Unsigned16	abtsc;	// User
	/** */
	Unsigned16	nmarc;	// User
	/** */
	Unsigned16	retrc;	// User
	/** */
	Unsigned16	mflr;	// User
	/** */
	Unsigned16	max_cnt;
	/** */
	Unsigned16	rfthr;	// User
	/** */
	Unsigned16	rfcnt;
	/** */
	Unsigned16	hmask;	// User
	/** */
	Unsigned16	haddr1;	// User
	/** */
	Unsigned16	haddr2;	// User
	/** */
	Unsigned16	haddr3;	// User
	/** */
	Unsigned16	haddr4;	// User
	/** */
	Unsigned16	tmp;
	/** */
	Unsigned16	tmp_mb;
	} HDLC;
}
}
}
}

#endif
