/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_headerh_
#define _oscl_hw_motorola_mpc8xx_pram_headerh_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {

/** */
typedef struct Header {
	/** */
	Unsigned16	rbase;	// User
	/** */
	Unsigned16	tbase;	// User
	/** */
	Oscl::BitField<Unsigned8>	rfcr;	// User
	/** */
	Oscl::BitField<Unsigned8>	tfcr;	// User
	/** */
	Unsigned16	mrblr;	// User
	/** */
	Unsigned32	rstate;
	/** */
	Unsigned32	rptr;
	/** */
	Unsigned16	rbptr;
	/** */
	Unsigned16	rcount;
	/** */
	Unsigned32	rtemp;
	/** */
	Unsigned32	tstate;
	/** */
	Unsigned32	tptr;
	/** */
	Unsigned16	tbptr;
	/** */
	Unsigned16	tcount;
	/** */
	Unsigned32	ttemp;
	} Header;

}
}
}

#endif
