/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_idmah_
#define _oscl_hw_motorola_mpc8xx_pram_idmah_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {

/** */
typedef struct IDMA {
	/** */
	Unsigned16							ibase;	// User
	/** */
	Oscl::BitField<Unsigned16>			dcmr;	// User
	/** */
	Unsigned32	sapr;
	/** */
	Unsigned32	dapr;
	/** */
	Unsigned16	ibptr;
	/** */
	Unsigned16	write_sp;
	/** */
	Unsigned32	s_byte_c;
	/** */
	Unsigned32	d_byte_c;	// 20
	/** */
	Unsigned32	s_state;	// 24
	/** */
	Unsigned32	itemp[4];	// 28
	/** */
	Unsigned32	sr_mem;		// 44
	/** */
	Unsigned16	read_sp;	// 48
	/** */
	Unsigned16	diff;		// 50
	/** */
	Unsigned16	tempaddr;	// 52
	/** */
	Unsigned16	sr_mem_byte_count;	// 54
	/** */
	Unsigned32	d_state;	// 56
	/** */
	unsigned char	reserved[0x40-60];
	} IDMA;

/** */
typedef struct IDMA_single_buffer {
	/** */
	Unsigned32	bapr;	// User
	/** */
	Unsigned32	bcr;	// User
	/** */
	Unsigned32	dcmr;	// User
	/** */
	char		reserved[0x40-0x0C];
	} IDMA_single_buffer;

}
}
}

#endif
