/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_piph_
#define _oscl_hw_motorola_mpc8xx_pram_piph_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {

/** */
typedef union PIP {
	/** */
	struct {
		/** */
		Unsigned16	reserved1;
		/** */
		Unsigned16	tbase;	// User
		/** */
		Unsigned8	pfcr;	// User
		/** */
		Unsigned8	smask;	// User
		/** */
		Unsigned8	reserved2[0x18-0x06];
		/** */
		Unsigned32	tstate;
		/** */
		Unsigned32	t_ptr;
		/** */
		Unsigned16	tbptr;
		/** */
		Unsigned16	t_cnt;
		/** */
		Unsigned32	ttemp;
		}tx;
	/** */
	struct {
		/** */
		Unsigned16	rbase;	// User
		/** */
		Unsigned16	reserved1;
		/** */
		Unsigned8	pfcr;	// User
		/** */
		Unsigned8	reserved2;
		/** */
		Unsigned16	mrblr;	// User
		/** */
		Unsigned32	rstate;
		/** */
		Unsigned32	r_ptr;
		/** */
		Unsigned16	rbptr;
		/** */
		Unsigned16	r_cnt;
		/** */
		Unsigned32	rtemp;
		/** */
		Unsigned8	reserved3[0x28-0x18];
		/** */
		Unsigned16	max_sl;	// User
		/** */
		Unsigned16	sl_cnt;
		/** */
		Unsigned16	character1;	// User
		/** */
		Unsigned16	character2;	// User
		/** */
		Unsigned16	character3;	// User
		/** */
		Unsigned16	character4;	// User
		/** */
		Unsigned16	character5;	// User
		/** */
		Unsigned16	character6;	// User
		/** */
		Unsigned16	character7;	// User
		/** */
		Unsigned16	character8;	// User
		/** */
		Unsigned16	rccm;	// User
		/** */
		Unsigned16	rccr;
		} rx;
	} PIP;

}
}
}

#endif
