/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_smch_
#define _oscl_hw_motorola_mpc8xx_pram_smch_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"
#include "header.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {

/** */
typedef struct SMC {
	/** */
	Header		header;
	/** */
	union {
		/** */
		struct {
			/** */
			Unsigned16	max_idl;	// User
			/** */
			Unsigned16	idlc;
			/** */
			Unsigned16	brkln;
			/** */
			Unsigned16	brkec;	// User
			/** */
			Unsigned16	brkcr;	// User
			/** */
			Unsigned16	r_mask;
			} UART;
		/** */
		struct {
			/** */
			Unsigned16	reserved[0x32-0x28];
			} TRANS;
		/** */
		struct {
			/** */
			Unsigned16	m_rxbd;	// User
			/** */
			Unsigned16	m_txbd;	// User
			/** */
			Unsigned16	ci_rxbd;	// User
			/** */
			Unsigned16	ci_txbd;	// User
			/** */
			Unsigned32	rstate;
			/** */
			Unsigned16	m_rxd;
			/** */
			Unsigned16	m_txd;
			/** */
			Unsigned16	ci_rxd;
			/** */
			Unsigned16	ci_txd;
			} GCI;
		unsigned char	pad[0x40-0x28];
		} psa;
	} SMC;

}
}
}

#endif
