/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_motorola_mpc8xx_pram_uarth_
#define _oscl_hw_motorola_mpc8xx_pram_uarth_
#include "oscl/compiler/types.h"
#include "oscl/bits/bitfield.h"
#include "header.h"

/** */
namespace Oscl {
/** */
namespace Mot8xx {
/** */
namespace Pram {
/** */
namespace SCC {

/** */
typedef struct UART {
	/** */
	Header		header;
	/** */
	Unsigned32	rcrc;
	/** */
	Unsigned32	tcrc;
	/** */
	Unsigned32	reserved[2];
	/** */
	Unsigned16	max_idl;	// User
	/** */
	Unsigned16	idlc;
	/** */
	Unsigned16	brkcr;	// User
	/** */
	Unsigned16	parec;	// User
	/** */
	Unsigned16	frmec;	// User
	/** */
	Unsigned16	nosec;	// User
	/** */
	Unsigned16	brkec;	// User
	/** */
	Unsigned16	brkln;
	/** */
	Unsigned16	uaddr1;	// User
	/** */
	Unsigned16	uaddr2;	// User
	/** */
	Unsigned16	rtemp;
	/** */
	Unsigned16	toseq;	// User
	/** */
	Unsigned16	character1;	// User
	/** */
	Unsigned16	character2;	// User
	/** */
	Unsigned16	character3;	// User
	/** */
	Unsigned16	character4;	// User
	/** */
	Unsigned16	character5;	// User
	/** */
	Unsigned16	character6;	// User
	/** */
	Unsigned16	character7;	// User
	/** */
	Unsigned16	character8;	// User
	/** */
	Unsigned16	rccm;	// User
	/** */
	Unsigned16	rccr;
	/** */
	Unsigned16	rlbc;
	} UART;

}
}
}
}

#endif
