/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _hw_mot8xx_pramregh_
#define _hw_mot8xx_pramregh_
#include "oscl/compiler/types.h"
namespace Oscl { // Namespace description
	namespace Mot8xx { // Namespace description
		namespace PRAM { // Namespace description
			namespace IDMA { // Namespace description
				namespace IBASE { // Register description
					typedef Unsigned16	Reg;
					};
				namespace DCMR { // Register description
					typedef Unsigned16	Reg;
					};
				namespace SAPR { // Register description
					typedef Unsigned32	Reg;
					};
				namespace DAPR { // Register description
					typedef Unsigned32	Reg;
					};
				namespace IBPTR { // Register description
					typedef Unsigned16	Reg;
					};
				namespace WRITE_SP { // Register description
					typedef Unsigned16	Reg;
					};
				namespace S_BYTE_C { // Register description
					typedef Unsigned32	Reg;
					};
				namespace S_STATE { // Register description
					typedef Unsigned32	Reg;
					};
				namespace ITEMP { // Register description
					typedef Unsigned32	Reg;
					};
				namespace SR_MEM { // Register description
					typedef Unsigned32	Reg;
					};
				namespace READ_SP { // Register description
					typedef Unsigned32	Reg;
					};
				namespace D_STATE { // Register description
					typedef Unsigned32	Reg;
					};
				};
			namespace RBASE { // Register description
				typedef Unsigned16	Reg;
				};
			namespace TBASE { // Register description
				typedef Unsigned16	Reg;
				};
			namespace FCR { // Register description
				typedef Unsigned8	Reg;
				namespace AT { // Field Description
					enum {Lsb = 0};
					enum {FieldMask = 0x00000007};
					};
				namespace BO { // Field Description
					enum {Lsb = 0};
					enum {FieldMask = 0x00000007};
					enum {Value_PowerPCLE = 0x1};
					enum {ValueMask_PowerPCLE = 0x00000001};
					enum {Value_BigEndian = 0x2};
					enum {ValueMask_BigEndian = 0x00000002};
					enum {Value_LittleEndian = 0x2};
					enum {ValueMask_LittleEndian = 0x00000002};
					};
				};
			namespace MRBLR { // Register description
				typedef Unsigned16	Reg;
				};
			namespace RSTATE { // Register description
				typedef Unsigned32	Reg;
				};
			namespace RxDataPtr { // Register description
				typedef Unsigned32	Reg;
				};
			namespace RBPTR { // Register description
				typedef Unsigned16	Reg;
				};
			namespace RxByteCount { // Register description
				typedef Unsigned16	Reg;
				};
			namespace RxTemp { // Register description
				typedef Unsigned32	Reg;
				};
			namespace TSTATE { // Register description
				typedef Unsigned32	Reg;
				};
			namespace TxDataPtr { // Register description
				typedef Unsigned32	Reg;
				};
			namespace TBPTR { // Register description
				typedef Unsigned16	Reg;
				};
			namespace TxByteCount { // Register description
				typedef Unsigned16	Reg;
				};
			namespace TxTemp { // Register description
				typedef Unsigned32	Reg;
				};
			};
		};
	};
#endif
