/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_hw_usb_hub_statush_
#define _oscl_hw_usb_hub_statush_
#include "oscl/compiler/types.h"
namespace Oscl { // Namespace description
	namespace Usb { // Namespace description
		namespace Hw { // Namespace description
			namespace Hub { // Namespace description
				namespace wStatus { // Register description
					typedef Unsigned16	Reg;
					namespace LocalPowerSource { // Field Description
						enum {Lsb = 0};
						enum {FieldMask = 0x00000001};
						enum {Value_Good = 0x0};
						enum {ValueMask_Good = 0x00000000};
						enum {Value_Lost = 0x1};
						enum {ValueMask_Lost = 0x00000001};
						};
					namespace OverCurrent { // Field Description
						enum {Lsb = 1};
						enum {FieldMask = 0x00000002};
						enum {Value_Inactive = 0x0};
						enum {ValueMask_Inactive = 0x00000000};
						enum {Value_Active = 0x1};
						enum {ValueMask_Active = 0x00000002};
						};
					};
				namespace wChange { // Register description
					typedef Unsigned16	Reg;
					namespace LocalPowerSource { // Field Description
						enum {Lsb = 0};
						enum {FieldMask = 0x00000001};
						enum {Value_NoChange = 0x0};
						enum {ValueMask_NoChange = 0x00000000};
						enum {Value_Changed = 0x1};
						enum {ValueMask_Changed = 0x00000001};
						};
					namespace OverCurrent { // Field Description
						enum {Lsb = 1};
						enum {FieldMask = 0x00000002};
						enum {Value_NoChange = 0x0};
						enum {ValueMask_NoChange = 0x00000000};
						enum {Value_Changed = 0x1};
						enum {ValueMask_Changed = 0x00000002};
						};
					};
				};
			};
		};
	};
#endif
