/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "macro.h"

    .h8300h
	.section .bss
	.globl	__counter
__counter:
	.zero	1

	.text
	.globl	StartOOOS
/*************************
 * StartOOOS
 * Input: Frame pointer in R2
 */
StartOOOS:
	mov.l	er0,er7
/*	pop.l	er6 */
	__restoreContext
	rte

	.globl	__h8300hTrap0

/* This operation emulates a systemCall TRAP.
 * On entry, the specific system call reference
 * is in R2.
 */
__h8300hTrap0:
	__saveContext
	mov.l	er7,er0
	mov.l	#_stack,er7
	jsr		_h8SystemCall
	jsr		_Schedule
	mov.l	er0,er7
	__restoreContext
	rte

	.globl	__h8300hTimerAOverflow

/* 
 *  Deal with timer A (SystemTimer) interrupt.
 */
__h8300hTimerAOverflow:
	/* The timer interrupt is divided by 3
	 * before the h8SystemTick is invoked.
	 */
	push.l	er0
	mov.b	@__counter:16,r0l
	beq		1f
	dec.b	r0l
	mov.b	r0l,@__counter:16
	pop.l	er0
	rte
1:
	mov.b	#3,r0l
	mov.b	r0l,@__counter:16
	pop.l	er0

	__saveContext
	mov.l	er7,er0
	mov.l	#_stack,er7
	jsr		_h8SystemTick
	jsr		_Schedule
	mov.l	er0,er7
	__restoreContext
	rte

