/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "frame.ah.h"
#include "scratch.ah.h"
#include "oscl/hw/powerpc/uisa.asm.h"
#include "oscl/hw/powerpc/oea.asm.h"
#include "oscl/hw/motorola/mpc8xx/spr.asm.h"

// This SPRG holds the SMP processor instance
// scratch area.
#define SmpScratchSprg		PpcOeaSprSPRG0

// This SPRG holds the frame pointer / stack pointer
// during first level exception processing.
#define ExceptScratchSprg	PpcOeaSprSPRG1

// This is used to hold the Thread/Frame pointer
// for now.
#define FrameSprg			PpcOeaSprSPRG2

// This holds the SMP processor specific
// exception stack pointer base (top).
#define SmpStackPtrSprg		PpcOeaSprSPRG3

// This just symbolically represents the GPR
// used as the frame/stack pointer.
#define StackPtrGpr			PpcUisaGPR1

#define FramePtrGpr			PpcUisaGPR3


