/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "sprg.h"

	.text
	.globl	__sprgInit
__sprgInit:
// This routine is responsible for assigning
// a scratch area to each different processor
// in a SMP configuration. The scratch area
// is define by the structure SmpControlBlock.
// The SmpControlBlock contains exception stack
// area(s) and current thread and memory space
// references.
//
// Since the MPC8xx family does not support SMP
// This assignment is simply managed by allocating
// the processor a SmpControlBlock, which contains
// SPRG registers, and 
// link register to an assembly language routine
// that:
//	a.	Operates without a stack
//	b.	Determines the content SMP SPRGs:
//			- SmpScratchSprg
//			- SmpStackPtrSprg
//	c.	Sets GPR1 to the SMP stack pointer.
//	d.	Sets GPR3 to a non-zero value if this is
//		the "master" processor that is responsible
//		for initializing global resources.
//	e.	Returns to the link register location.
// FIXME
	// Load reference to Oscl::Rtk::SmpInstance
	// into SPRG SmpScratchSprg
	lis	OsclPpcUisaGPR1,__SMP_SUPER_STACK_PAGE__@h
	ori	OsclPpcUisaGPR1,OsclPpcUisaGPR1,__SMP_SUPER_STACK_PAGE__@l
	mtspr	SmpScratchSprg ,OsclPpcUisaGPR1
	mtspr	FrameSprg,OsclPpcUisaGPR1

	// Load the SMP stack pointer
	lis	OsclPpcUisaGPR1,__SMP_SUPER_STACK_END__@h
	ori	OsclPpcUisaGPR1,OsclPpcUisaGPR1,__SMP_SUPER_STACK_END__@l
	mtspr	SmpStackPtrSprg,OsclPpcUisaGPR1

	// Mark this as the processor responsible for
	// initializing global resources.
	li	OsclPpcUisaGPR3,-1

	blr

