/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_krux_platform_ppc_syspageh_
#define _oscl_krux_platform_ppc_syspageh_
#include "page.h"
#include "oscl/queue/queue.h"

/** */
class SystemPage {
	private:
		/** */
		Oscl::Queue< OoosPage >	freePages;
		/** */
		Oscl::Queue< OoosPage >	freeUsedPages;
		/** */
		unsigned				_nFreePages;
		/** */
		unsigned				_nUsedPages;
		/** */
		unsigned				_nAllocedMmuPages;
		/** */
		unsigned				_nAllocedHeapPages;
	public:
		/** */
		SystemPage() throw();
		/** */
		OoosPage*	allocHeap() throw();
		/** */
		OoosPage*	allocMMU() throw();
		/** */
		void		freeMMU(OoosPage* page) throw();
	public:
		/** */
		unsigned	nFreePages() const throw();
		/** */
		unsigned	nUsedPages() const throw();
		/** */
		unsigned	nAllocedMmuPages() const throw();
		/** */
		unsigned	nAllocedHeapPages() const throw();
	private:
		/** */
		OoosPage*	allocFreePage() throw();
		/** */
		void		freeUsedPage(OoosPage* page) throw();
		/** */
		OoosPage*	allocUsedPage() throw();
	};

extern SystemPage	OoosGlobalSystemPage;	// Located in linker script

#endif
