/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_mt_itc_dyn_adv_cli_respmemh_
#define _oscl_mt_itc_dyn_adv_cli_respmemh_
#include "respapi.h"
#include "oscl/memory/block.h"

/** */
namespace Oscl {
/** */
namespace Mt {
/** */
namespace Itc {
/** */
namespace Dyn {
/** */
namespace Adv {
/** */
namespace Cli {
/** */
namespace Resp {

/** */
template <class dynSrvType>
union CreateMem {
	/** */
	Oscl::Memory::Block<	sizeof(	typename Oscl::Mt::Itc::Dyn::Adv::
									Cli::Req::Api<dynSrvType>::CreatePayload
									)
							>	payloadx;
	/** */
	Oscl::Memory::Block<	sizeof(	typename Oscl::Mt::Itc::Dyn::Adv::
									Cli::Resp::Api<dynSrvType>::CreateResp
									)
							>	resp;
	};

/** */
template <class dynSrvType>
union CancelMem {
	/** */
	Oscl::Memory::Block<	sizeof(	typename Oscl::Mt::Itc::Dyn::Adv::
									Cli::Req::Api<dynSrvType>::CancelPayload
									)
							>	payload;
	/** */
	Oscl::Memory::Block<	sizeof(	typename Oscl::Mt::Itc::Dyn::Adv::
									Cli::Resp::Api<dynSrvType>::CancelResp
									)
							>	resp;
	};


}
}
}
}
}
}
}

#endif
