/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_mt_itc_mbox_saph_
#define _oscl_mt_itc_mbox_saph_
#include "oscl/mt/itc/postmsgapi.h"

/** */
namespace Oscl {
/** */
namespace Mt {
/** */
namespace Itc {

/** */
template <class ReqApi>
class SAP : public PostMsgApi {
	public:
		/** */
		virtual ReqApi&			getReqApi() const throw()=0;
		/** */
		virtual void			post(Msg& msg) throw()=0;
		/** */
		virtual void			postSync(Msg& msg) throw()=0;
	};

/** */
template <class ReqApi>
class ConcreteSAP : public SAP<ReqApi> {
	private:
		/** */
		ReqApi&				_api;
		/** */
		PostMsgApi&			_papi;
	public:
		/** */
		ConcreteSAP(ReqApi& api,PostMsgApi& papi) throw();
	public:
		/** */
		ReqApi&			getReqApi() const throw();
		/** */
		void			post(Msg& msg) throw();
		/** */
		void			postSync(Msg& msg) throw();
	};

template <class ReqApi>
ConcreteSAP<ReqApi>::ConcreteSAP(	ReqApi&		api,
									PostMsgApi&	papi
									) throw():
		_api(api),
		_papi(papi)
		{
	}

template <class ReqApi>
ReqApi& ConcreteSAP<ReqApi>::getReqApi() const throw() {
	return _api;
	}

template <class ReqApi>
void ConcreteSAP<ReqApi>::post(Msg& msg) throw() {
	_papi.post(msg);
	}

template <class ReqApi>
void ConcreteSAP<ReqApi>::postSync(Msg& msg) throw() {
	_papi.postSync(msg);
	}

}
}
}

#endif
