/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_mt_itc_server_openh_
#define _oscl_mt_itc_server_openh_
#include "oscl/mt/itc/postmsgapi.h"
#include "opensyncapi.h"
#include "openapi.h"

/** */
namespace Oscl {
/** */
namespace Mt {
/** */
namespace Itc {
/** */
namespace Srv {

/** */
class OpenSync : public OpenSyncApi {
	private:
		/** */
		Open::Req::Api::ConcreteSAP	_sap;
	public:
		/** */
		OpenSync(	Open::Req::Api&	reqApi,
					PostMsgApi&		papi
					) throw();
		/** */
		virtual ~OpenSync() {}
	public:
		/** */
		void	syncOpen() throw();
		/** */
		Open::Req::Api::SAP&	getSAP() throw();
	};

}
}
}
}

#endif
