/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "oscl/timer/tocks.h"

unsigned long	OsclTimerMillisecondsToTocks(unsigned long milliseconds) throw(){
	// FIXME: These values have NOT been verified.
	// The TimerA is set to a period of approximately 31.25ms which
	// corresponds to a frequency of 32Hz.
	milliseconds	= (milliseconds)?milliseconds:1;// At least 1 millisecond
	const unsigned long	maxMilliseconds	= ~0;
	if(milliseconds < (maxMilliseconds/100)){
		// High resolution for small values of "millseconds"
		const unsigned long	tPerTock	= 3125;// 3125 *10^-5 per tock
		milliseconds 	*= 100; // Scale milliseconds from 10^3 to 10^-5
		milliseconds	+= (tPerTock-1);	// round up
		milliseconds	/= tPerTock;		// Scale to tocks * 10^2
		}
	else{
		// Low resolution for large values of milliseconds
		const unsigned long	tPerTock	= 31;	// 31 per tock
		milliseconds	+= (tPerTock-1);	// roundup
		milliseconds	/= tPerTock;
		}
	return milliseconds;	// actually now Tocks
	}

