/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "part.h"
#include "oscl/fs/file/rw/handle.h"

using namespace Oscl::Persist::Record::FS::RW;

Part::Part(	Oscl::FS::File::RW::Handle&			fileHandle,
			Oscl::FS::File::RW::Access::Api&	woApi,
			Oscl::FS::File::RO::Access::Api&	roApi,
			unsigned							offset
			) throw():
		_fileHandle(fileHandle),
		_woApi(woApi),
		_roApi(roApi),
		_offset(offset)
		{
	}

void	Part::read(	void*		dest,
					unsigned	length,
					unsigned	offset
					) const throw(){
	unsigned long	nRead;
	_roApi.read(	_fileHandle,
					dest,
					(unsigned long)length,
					(unsigned long)(offset+_offset),
					nRead
					);
	}

void	Part::write(	const void*	src,
						unsigned	length,
						unsigned	offset
						) const throw(){
	unsigned long	nWritten;
	_woApi.write(_fileHandle,src,length,offset+_offset,nWritten);
	}

