/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_kernel_platform_mplockh_
#define _oscl_kernel_platform_mplockh_

#ifndef _oscl_kernel_mplockh_
#warning "NEVER include this file directly. #include oscl/kernel/mplock.h instead."
#endif

extern "C"{
	/** */
	inline void	OsclKernelGlobalMpLockAquire(Oscl::Kernel::IrqMaskState& savedMask) throw(){
#if 0
		// FIXME: There should be separate versions of this
		// operation for Multi-Processor systems (e.g. SMP) and
		// Uni-Processor systems. The Uni-Processing variant would
		// simply be an alias for OsclKernelDisableInterrupts().
		extern volatile unsigned long	GlobalMpLockVariable;
		unsigned long	mutex;

		while(true){
			mutex	= Oscl::Ppc::lwarx(&GlobalMpLockVariable);
			if(mutex++){	// NOTE: *post* increment
				// Mutex is locked. Poll until cleared. 
				continue;
				}
			OsclKernelDisableInterrupts(savedMask);
			bool	locked	= Oscl::Ppc::stwcx(&GlobalMpLockVariable,mutex);
			if(locked){
				// PowerPC programming environments manual
				// appendix example E2.5 .
				// The isync instruction is used instead
				// of the sync instruction since memory
				// accesses do not need to complete before
				// subsequent instructions.
				Oscl::Ppc::isync();
				return;
				}
			else {
				OsclKernelRestoreInterruptState(savedMask);
				}
			}
#endif
		}

	/** */
	inline void		OsclKernelGlobalMpLockRestore(const Oscl::Kernel::IrqMaskState& savedLevel) throw(){
#if 0
		// FIXME: There should be separate versions of this
		// operation for Multi-Processor systems (e.g. SMP) and
		// Uni-Processor systems. The Uni-Processing variant would
		// simply be an alias for OsclKernelRestoreInterruptState().
		extern volatile unsigned long	GlobalMpLockVariable;
		Oscl::Ppc::sync();
		GlobalMpLockVariable	= 0;
		OsclKernelRestoreInterruptState(savedLevel);
#endif
		}
	}

#endif
