/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_target_frameh_
#define _oscl_target_frameh_
#include "oscl/compiler/types.h"

typedef struct OsclKruxFrame {
	// FIXME
	// This should be the registers
	// saved by an INTERRUPT() routine
	// followd by the other registers.
	Oscl::Unsigned32	r7;
	Oscl::Unsigned32	r6;
	Oscl::Unsigned32	r5;
	Oscl::Unsigned32	r4;
	Oscl::Unsigned32	r3;
	Oscl::Unsigned32	r2;
	Oscl::Unsigned32	r1;
	Oscl::Unsigned32	r0;
	struct {
		Oscl::Unsigned8	ccr;
		Oscl::Unsigned8	nu;
		void		(*pc)();	// Assumes pointers are 16 bits (H8 Normal Mode)
		};
	}OsclKruxFrame;

#endif /* _target_frameh_ */

