/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_krux_target_frameh_
#define _oscl_krux_target_frameh_
#include "oscl/compiler/types.h"

	/** This data structure describes the thread stack frame
		used by the Krux RTOS.
	 */
	typedef struct OsclKruxFrame{
		Oscl::Unsigned32	d0;
		Oscl::Unsigned32	d1;
		Oscl::Unsigned32	d2;
		Oscl::Unsigned32	d3;
		Oscl::Unsigned32	d4;
		Oscl::Unsigned32	d5;
		Oscl::Unsigned32	d6;
		Oscl::Unsigned32	d7;
		Oscl::Unsigned32	a1;
		Oscl::Unsigned32	a2;
		Oscl::Unsigned32	a3;
		Oscl::Unsigned32	a4;
		Oscl::Unsigned32	a5;
		Oscl::Unsigned32	a6;
		Oscl::Unsigned32	a0;
		Oscl::Unsigned16	sr;
		void		(*pc)(void);	/* Program Counter at time of KS or interrupt */
		Oscl::Unsigned16	format;
		}OsclKruxFrame;

#endif

