/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_mt_itc_mbox_platform_semah_
#define _oscl_mt_itc_mbox_platform_semah_
#include <semaphore.h>
#include "oscl/mt/sema/api.h"
#include "oscl/mt/itc/mbox/platform/sema.h"

/** */
namespace Oscl {
/** */
namespace Mt {
/** */
namespace Itc {

/** */
class MailboxSema : public Oscl::Mt::Sema::Api {
	private:
		/** */
		sem_t	_sema;

	public:
		/** */
		MailboxSema() throw();

		/** */
		~MailboxSema();

		/** */
		inline void	signal() throw(){
			sem_post(&_sema);
			}

		/** */
		inline void	wait() throw(){
			sem_wait(&_sema);
			}

		/** */
		inline void	suSignal() throw(){
			sem_post(&_sema);
			}
	};

}
}
}

#endif
