/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "oscl/hw/powerpc/uisa.asm.h"

	.text
/******************* Cache Manipulators *************************/
/* These sizes are correct for the MPC8xx PowerPC family */
#define CACHE_LINE_SIZE		16
#define LG_CACHE_LINE_SIZE	4

/*************************
 * OsclCacheDataFlushRange(void* base,unsigned long size)
 */
	.globl	OsclCacheDataFlushRange
OsclCacheDataFlushRange:
	/* Add almost line before rounding */
	addi	OsclPpcUisaGPR4,OsclPpcUisaGPR4,CACHE_LINE_SIZE-1
	/* convert N bytes to N words */
	srwi.	OsclPpcUisaGPR4,OsclPpcUisaGPR4,LG_CACHE_LINE_SIZE
	/* if N words is zero return */
	beqlr
	/* load counter with N words */
	mtctr	OsclPpcUisaGPR4
	/* Flush without invalidate */
1:	dcbst	0,OsclPpcUisaGPR3
	/* Next line */
	addi	OsclPpcUisaGPR3,OsclPpcUisaGPR3,CACHE_LINE_SIZE
	/* Decrement counter and cond loop */
	bdnz	1b
	blr

	.globl	OsclCacheDataInvalidateRange
OsclCacheDataInvalidateRange:
	/* Add almost line before rounding */
	addi	OsclPpcUisaGPR4,OsclPpcUisaGPR4,CACHE_LINE_SIZE-1
	/* convert N bytes to N words */
	srwi.	OsclPpcUisaGPR4,OsclPpcUisaGPR4,LG_CACHE_LINE_SIZE
	/* if N words is zero return */
	beqlr
	/* load counter with N words */
	mtctr	OsclPpcUisaGPR4
	/* Invalidate line */
1:	dcbi	0,OsclPpcUisaGPR3
	/* Next line */
	addi	OsclPpcUisaGPR3,OsclPpcUisaGPR3,CACHE_LINE_SIZE
	/* Decrement counter and cond loop */
	bdnz	1b
	blr

#if 0
	/* This is directly from Linux
		flush_dcache_range(unsigned long start,unsigned long stop)
	 */
	li      r5,CACHE_LINE_SIZE-1
	andc    r3,r3,r5			/* Round to down to boundary */
	subf    r4,r3,r4			/* calculate n bytes in range */
	add     r4,r4,r5			/* round up to boundary */
	srwi.   r4,r4,LG_CACHE_LINE_SIZE	/* convert N bytes to N words */
	beqlr						/* if N words is zero return */
	mtctr   r4					/* load counter with N words */
1:	dcbst   0,r3				/* Flush without invalidate */
	addi    r3,r3,CACHE_LINE_SIZE
	bdnz    1b
	sync                            /* wait for dcbst's to get to ram */
	blr

#endif
