/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_ppp_layer_lcp_rxtransh_
#define _oscl_ppp_layer_lcp_rxtransh_
#include "oscl/frame/pdu/rx/respapi.h"

/** */
namespace Oscl {
/** */
namespace PPP {
/** */
namespace Layer {
/** */
namespace LCP {

/** */
class Part;

/** */
class RxTrans :	private Oscl::Frame::Pdu::Rx::Resp::Api
				{
	public:
		/** */
		Oscl::Frame::Pdu::Rx::Req::Api::RxPayload		_payload;
	private:
		/** */
		Oscl::Frame::Pdu::Rx::Resp::Api::RxResp			_resp;
		/** */
		class Part&										_context;

	public:
		/** */
		RxTrans(	Part&									context,
					Oscl::Mt::Itc::PostMsgApi&				myPapi,
					Oscl::Frame::Pdu::Rx::Req::Api::SAP&	rxSAP
					) throw();

	private:	// Oscl::Frame::Pdu::Rx::Resp::Api
		/** */
		void	response(	Oscl::Frame::Pdu::Rx::
							Resp::Api::RxResp&		msg
							) throw();

		/** */
		void	response(	Oscl::Frame::Pdu::Rx::
							Resp::Api::CancelAllResp&	msg
							) throw();
	};

}
}
}
}

#endif
