/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_preitc_mbox_c1h_
#define _oscl_preitc_mbox_c1h_
#include "s1.h"
#include "oscl/krux/timer/sematimer.h"
#include "oscl/krux/sema/bsema.h"
#include "oscl/mt/runnable.h"

/** */
namespace Oscl {

/** Client number 1 thread.
 */

class C1 : public Mt::Runnable {
	private:
		S1Srv&				_srv;
		Krux::Sema::Binary	_sema;
		Krux::SemaTimer		_timer;
	public:
		C1(S1Srv& srv);
		virtual ~C1();
		/** Client 1 run method.
		 */
		void run() throw();
	};

}

#endif
