/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "part.h"

using namespace Oscl::Protocol::IP::Socket::UDP::Srv::Subsystem::RX;

Part::Part(	Oscl::Mt::Itc::PostMsgApi&			subsysRxPapi,
			Oscl::Mt::Itc::PostMsgApi&			socketRxPapi,
			unsigned							localPort,
			Oscl::Protocol::IP::
			Port::Mux::Client::Receiver&		receiver,
			Oscl::Protocol::IP::
			Port::Mux::Srv::Client::TransMem	clientTransMem[],
			unsigned							nClientTransMem
			) throw():
		_server(	subsysRxPapi,
					localPort
					),
		_client(	socketRxPapi,
					_server.getSAP(),
					receiver,
					clientTransMem,
					nClientTransMem
					)
		{
	}

Oscl::Protocol::IP::Port::Mux::Registrar::Acceptor&	Part::getAcceptor() throw(){
	return _server;
	}

void	Part::syncOpen() throw(){
	_client.syncOpen();
	}

void	Part::syncClose() throw(){
	_client.syncClose();
	}

