/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_protocol_ip_tcp_conn_mux_registrar_srv_synch_
#define _oscl_protocol_ip_tcp_conn_mux_registrar_srv_synch_
#include "reqapi.h"
#include "oscl/protocol/ip/tcp/conn/mux/registrar/api.h"

/** */
namespace Oscl {
/** */
namespace Protocol {
/** */
namespace IP {
/** */
namespace TCP {
/** */
namespace Conn {
/** */
namespace Mux {
/** */
namespace Registrar {
/** */
namespace Srv {

/**	*/
class Sync : public Oscl::Protocol::IP::TCP::Conn::Mux::Registrar::Api {
	private:
		/** */
		Oscl::Protocol::IP::
		TCP::Conn::Mux::Registrar::Srv::Req::Api::SAP&	_sap;

	public:
		/** */
		Sync(	Oscl::Protocol::IP::
				TCP::Conn::Mux::Registrar::Srv::Req::Api::SAP&	sap
				) throw();

	public:	// Api
		/** */
		Oscl::Protocol::IP::
		TCP::Conn::Mux::Registrar::Path*	listen(	Oscl::Protocol::IP::
													TCP::Conn::Mux::
													Registrar::Path&	path
													) throw();
		/** */
		void	reject(	const Oscl::Protocol::IP::
						TCP::Conn::Mux::Registrar::Path&	path
						) throw();
		/** */
		void	attach(	Oscl::Protocol::IP::
						TCP::Conn::Mux::Registrar::Acceptor&	acceptor
						) throw();
		/** */
		void	detach(	Oscl::Protocol::IP::
						TCP::Conn::Mux::Registrar::Acceptor&	acceptor
						) throw();
	};

}
}
}
}
}
}
}
}

#endif
