/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_protocol_ip_tcp_conn_srv_server_rxh_
#define _oscl_protocol_ip_tcp_conn_srv_server_rxh_
#include "oscl/protocol/ip/tcp/conn/mux/registrar/api.h"
#include "oscl/protocol/ip/tcp/conn/mux/registrar/acceptor.h"
#include "oscl/protocol/ip/tcp/conn/mux/registrar/path.h"
#include "oscl/protocol/ip/tcp/conn/fsm/var.h"
#include "oscl/stream/input/itc/sync.h"
#include "oscl/stream/output/itc/sync.h"
#include "oscl/stream/io/api.h"
#include "oscl/mt/itc/srv/closeapi.h"
#include "oscl/mt/itc/srv/close.h"
#include "trans.h"

/** */
namespace Oscl {
/** */
namespace Protocol {
/** */
namespace IP {
/** */
namespace TCP {
/** */
namespace Conn {
/** */
namespace Srv {
/** */
namespace Server {

/** */
class RxContext {
	public:
		/** */
		virtual void	rxRequest(	Oscl::Stream::Input::
									Req::Api::ReadReq&		msg
									) throw()=0;
	};

/** */
class Rx :	private	Oscl::Stream::Input::Req::Api {
	private:
		/** */
		Oscl::Mt::Itc::PostMsgApi&			_myPapi;
		/** */
		Oscl::Stream::Input::Sync			_inputSync;
		/** */
		RxContext&							_context;

	public:
		/** */
		Rx(		Oscl::Mt::Itc::PostMsgApi&	myPapi,
				RxContext&					context
				) throw();

		/** */
		Oscl::Stream::Input::Req::Api::SAP&		getInputSAP() throw();
		/** */
		Oscl::Stream::Input::Api&				getSyncApi() throw();

	private: // Oscl::Stream::Input::Req::Api
		/** */
		void	request(Oscl::Stream::Input::Req::Api::ReadReq& msg) throw();
		/** */
		void	request(Oscl::Stream::Input::Req::Api::CancelReq& msg) throw();
	};

}
}
}
}
}
}
}

#endif
