/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_protocol_ip_udp_port_rx_mux_apih_
#define _oscl_protocol_ip_udp_port_rx_mux_apih_
#include "oscl/protocol/ip/udp/port/rx/entry.h"

/** */
namespace Oscl {
/** */
namespace Protocol {
/** */
namespace IP {
/** */
namespace UDP {
/** */
namespace Port {
/** */
namespace RX {
/** */
namespace Mux {

/** */
class Api : public Oscl::Protocol::IP::UDP::Port::RX::ForwardApi {
	public:
		virtual void	attach(	Oscl::Protocol::IP::
								UDP::Port::RX::Entry&	entry
								) throw()=0;
		virtual void	detach(	Oscl::Protocol::IP::
								UDP::Port::RX::Entry&	entry
								) throw()=0;

	public:	// Oscl::Protocol::IP::UDP::Port::RX::ForwardApi
		/** */
		virtual Oscl::PDU::Api* forward(	Oscl::PDU::Api&			frame,
											const Oscl::Protocol::
											IP::Port::Path&			path
											) throw()=0;
	};

}
}
}
}
}
}
}

#endif
