/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_scsi_cmd_read10h_
#define _oscl_scsi_cmd_read10h_
#include "oscl/compiler/types.h"

/** */
namespace Oscl {
/** */
namespace SCSI {
/** */
namespace CMD {
/** */
namespace Read10 {
/** */
struct Request {
	/** */
	const Unsigned8	_opcode;
	/** */
	Unsigned8		_flags;
	/** */
	Unsigned8		_lba[4];
	/** */
	Unsigned8		_reserved6;
	/** */
	Unsigned8		_transferLength[2];
	/** */
	Unsigned8		_control;
	/** */
	Request(	Unsigned8	flags,
				Unsigned32	lba,
				Unsigned16	transferLength,
				Unsigned8	control
				) throw():
		_opcode(0x28),
		_flags(flags),
		_reserved6(0),
		_control(control) {
		_transferLength[1]	= (Unsigned8)(transferLength >> 0);
		_transferLength[0]	= (Unsigned8)(transferLength >> 8);
		_lba[3]	= (Unsigned8)(lba >> 0);
		_lba[2]	= (Unsigned8)(lba >> 8);
		_lba[1]	= (Unsigned8)(lba >> 16);
		_lba[0]	= (Unsigned8)(lba >> 24);
		}
	};
/** */
struct Standard : public Request {
	/** */
	Standard(	Unsigned32	lba,
				Unsigned16	transferLength
				) throw():
		Request(0,lba,transferLength,0)
		{ }
	};
void print(const void* resp) throw();
}

}
}
}

#endif
