/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_shell_line_cmds_uart_dte_device_iterh_
#define _oscl_shell_line_cmds_uart_dte_device_iterh_
#include "oscl/shell/line/input.h"
#include "oscl/mt/itc/dyn/adv/clisync.h"
#include "oscl/uart/dyn/dte/device.h"

/** */
namespace Oscl {
/** */
namespace Shell {
/** */
namespace Line {
/** */
namespace Cmds {
/** */
namespace UART {
/** */
namespace DTE {
/** */
namespace Cmd {

class Iterate :	private	Oscl::Shell::Line::InputApi,
				private	Oscl::Mt::Itc::Dyn::Adv::
						Iterator<Oscl::UART::Dyn::DTE::Device>
				{
		/** */
		Oscl::Mt::Itc::Dyn::Adv::
		Cli::SyncApi<Oscl::UART::Dyn::DTE::Device>&	_findApi;

		/** */
		Oscl::ObjectID::Fixed<32>			_oid;

		/** */
		const char*							_cmd;

	public:
		/** */
		Iterate(	Oscl::Mt::Itc::Dyn::Adv::
					Cli::SyncApi<Oscl::UART::Dyn::DTE::Device>&	findApi,
					const char*									oid,
					const char*									cmd
					) throw();

		/** */
		InputApi*	start(Oscl::Stream::Output::Api& output) throw();

		/** */
		void	printDevice(	Oscl::Stream::Output::Api&			output,
								const Oscl::UART::Dyn::DTE::Device&	device
								) const throw();

	private:	// Oscl::Shell::Line::InputApi
		/** */
		InputApi*	input(	StateHeader&	state,
							const char*		inputLine
							) throw();

	private:	// Dyn::Adv::Iterator
		/** */
		bool	next(Oscl::UART::Dyn::DTE::Device& dev) throw();
	};

}
}
}
}
}
}
}

#endif
