/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "part.h"
#include "trans.h"

using namespace Oscl::Stream::Framer::RX::Srv;

ReadTrans::ReadTrans(	Part&								context,
						Oscl::Mt::Itc::PostMsgApi&			myPapi,
						Oscl::Stream::Input::Req::Api::SAP&	streamSAP,
						void*								buffer,
						unsigned							bufferSize
						) throw():
		_context(context),
		_myPapi(myPapi),
		_streamSAP(streamSAP),
		_payload(buffer,bufferSize),
		_resp(	streamSAP.getReqApi(),
				*this,
				myPapi,
				_payload
				)
		{
	_streamSAP.post(_resp.getSrvMsg());
	}

void	ReadTrans::cancel(	Oscl::Stream::Input::
							Resp::CancelRespMem&	mem
							) throw(){
	Oscl::Stream::Input::Req::Api::CancelPayload
		payload(_resp.getSrvMsg());
	Oscl::Stream::Input::Resp::Api::CancelResp
		resp(	_streamSAP.getReqApi(),
				*this,
				_myPapi,
				payload
				);
	_streamSAP.post(resp.getSrvMsg());
	}

void	ReadTrans::response(	Oscl::Stream::Input::
								Resp::Api::ReadResp&	msg
								) throw(){
	_context.done(*this);
	}

void	ReadTrans::response(	Oscl::Stream::Input::
								Resp::Api::CancelResp&	msg
								) throw(){
	_context.canceled(*this);
	}

