/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_stream_input_itc_reqapih_
#define _oscl_stream_input_itc_reqapih_
#include "oscl/buffer/base.h"
#include "oscl/mt/itc/mbox/srvreq.h"
#include "oscl/mt/itc/mbox/sap.h"
#include "oscl/buffer/var.h"

/** */
namespace Oscl {
/** */
namespace Stream {
/** */
namespace Input {
/** */
namespace Req {

/** */
class Api {
	public:
		/** */
		class ReadPayload {
			public:
				/** */
				Oscl::Buffer::Var	_buffer;
			public:
				/** */
				ReadPayload(Oscl::Buffer::Base&	buffer) throw();
				/** */
				ReadPayload(void* buffer,unsigned length) throw();
			};
		/** */
		typedef Oscl::Mt::Itc::SrvRequest<Api,ReadPayload>		ReadReq;
		/** */
		class CancelPayload {
			public:
				/** */
				ReadReq&	_readToCancel;
			public:
				/** */
				CancelPayload(ReadReq& readToCancel) throw();
			};
	public:
		/** */
		typedef Oscl::Mt::Itc::SrvRequest<Api,CancelPayload>	CancelReq;
		/** */
		typedef Oscl::Mt::Itc::SAP<Api>	SAP;
		/** */
		typedef Oscl::Mt::Itc::ConcreteSAP<Api>	ConcreteSAP;
	public:
		/** */
		virtual ~Api() {}
		/** */
		virtual void	request(ReadReq& msg) throw()=0;
		/** */
		virtual void	request(CancelReq& msg) throw()=0;
	};

}
}
}
}

#endif
