/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include <new>
#include <string.h>
#include "cmd.h"
#include "creator.h"

using namespace Oscl::TL1::Cmd::Dlt::Eqpt;

Creator::Creator() throw()
		{
	}

bool	Creator::match(const char* verb) const throw(){
	return !strcmp(verb,"DLT-EQPT");
	}

Oscl::TL1::Cmd::Api*
Creator::create(	void*							mem,
					unsigned						memSize,
					Oscl::TL1::Session::
					Output::Api&					output,
					Oscl::Mt::Itc::PostMsgApi&		myPapi,
					Oscl::TL1::Parser::Tokenizer&	tokenizer,
					Oscl::TL1::Parser::Error::Api&	errorApi,
					Oscl::TL1::Session::State::Api&	sessionApi
					) const throw(){
	if(memSize < sizeof(Command)){
		return 0;
		}

	return new (mem) Command(	output,
								myPapi,
								tokenizer
								);
	}

