/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "cmd.h"

using namespace Oscl::TL1::Cmd::Set::SID;

Command::Command(	Oscl::TL1::Session::Output::Api&	output,
					Oscl::Mt::Itc::PostMsgApi&			myPapi,
					Oscl::TL1::Parser::Tokenizer&		tokens,
					Oscl::TL1::Parser::Error::Api&		errorApi,
					Oscl::SysID::Control::Api&			sysIdApi
					) throw():
		Oscl::TL1::Cmd::Base::Output::Command(	output,
												myPapi,
												tokens
												),
		_errorApi(errorApi),
		_sysIdApi(sysIdApi),
		_outFunc(0)
		{
	}

void	Command::execute( Oscl::TL1::Cmd::DoneApi& done ) throw(){
	const Oscl::TL1::Parser::Parameter*
	param	= _tokens.parameter(0);
	if(!param){
		_outFunc	= &Command::missingParameter;
		}
	else {
		_sysIdApi.setSysID(param->_value);
		}
	Oscl::TL1::Cmd::Base::Output::Command::execute(done);
	}

void	Command::execute(Oscl::TL1::Output::Api& api) throw(){
	if(_outFunc){
		(*this.*_outFunc)(api);
		return;
		}
	api.completedResponseID(_tokens.ctag());
	api.terminator();
	}

void	Command::missingParameter(Oscl::TL1::Output::Api& api) throw(){
	_errorApi.missingParameter(api,_tokens.ctag());
	}

