/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#include "result.h"
#include "status.h"
#include "handler.h"

/** */
namespace Oscl {
/** */
namespace TL1 {
/** */
namespace Parser {
/** */
namespace Status {

//////////////////////////////////////////////////////
class VerbMissing : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void VerbMissing::query(Handler& handler) const throw(){
	handler.verbMissing();
	}

const Result&	verbMissing() throw(){
	static const VerbMissing	error;
	return error;
	}

//////////////////////////////////////////////////////
class VerbFieldMissing : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void VerbFieldMissing::query(Handler& handler) const throw(){
	handler.verbFieldMissing();
	}

const Result&	verbFieldMissing() throw(){
	static const VerbFieldMissing	error;
	return error;
	}

//////////////////////////////////////////////////////
class VerbTooLong : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void VerbTooLong::query(Handler& handler) const throw(){
	handler.verbTooLong();
	}

const Result&	verbTooLong() throw(){
	static const VerbTooLong	error;
	return error;
	}

//////////////////////////////////////////////////////
class TidFieldMissing : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void TidFieldMissing::query(Handler& handler) const throw(){
	handler.tidFieldMissing();
	}

const Result&	tidFieldMissing() throw(){
	static const TidFieldMissing	error;
	return error;
	}

//////////////////////////////////////////////////////
class TidTooLong : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void TidTooLong::query(Handler& handler) const throw(){
	handler.tidTooLong();
	}

const Result&	tidTooLong() throw(){
	static const TidTooLong	error;
	return error;
	}

//////////////////////////////////////////////////////
class AidFieldMissing : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void AidFieldMissing::query(Handler& handler) const throw(){
	handler.aidFieldMissing();
	}

const Result&	aidFieldMissing() throw(){
	static const AidFieldMissing	error;
	return error;
	}

//////////////////////////////////////////////////////
class AidTooLong : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void AidTooLong::query(Handler& handler) const throw(){
	handler.aidTooLong();
	}

const Result&	aidTooLong() throw(){
	static const AidTooLong	error;
	return error;
	}

//////////////////////////////////////////////////////
class CtagTooLong : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void CtagTooLong::query(Handler& handler) const throw(){
	handler.aidTooLong();
	}

const Result&	ctagTooLong() throw(){
	static const CtagTooLong	error;
	return error;
	}

//////////////////////////////////////////////////////
class CtagFieldMissing : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void CtagFieldMissing::query(Handler& handler) const throw(){
	handler.ctagFieldMissing();
	}

const Result&	ctagFieldMissing() throw(){
	static const CtagFieldMissing	error;
	return error;
	}

//////////////////////////////////////////////////////
class CtagInvalid : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void CtagInvalid::query(Handler& handler) const throw(){
	handler.ctagInvalid();
	}

const Result&	ctagInvalid() throw(){
	static const CtagInvalid	error;
	return error;
	}

//////////////////////////////////////////////////////
class TerminatorMissing : public Result {
	public:
		void	query(Handler& handler) const throw();
	};

void TerminatorMissing::query(Handler& handler) const throw(){
	handler.terminatorMissing();
	}

const Result&	terminatorMissing() throw(){
	static const TerminatorMissing	error;
	return error;
	}

}
}
}
}

