/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_tl1_parser_streamh_
#define _oscl_tl1_parser_streamh_
#include "handler.h"
#include "oscl/stream/output/api.h"

/** */
namespace Oscl {
/** */
namespace TL1 {
/** */
namespace Parser {
/** */
namespace Status {

/** */
class Stream : public Handler {
	private:
		/** */
		Oscl::Stream::Output::Api&	_out;
	public:
		/** */
		Stream(Oscl::Stream::Output::Api& out) throw();
	public:
		/** */
		void	verbMissing() const throw();
		/** */
		void	verbFieldMissing() const throw();
		/** */
		void	tidFieldMissing() const throw();
		/** */
		void	aidFieldMissing() const throw();
		/** */
		void	verbTooLong() const throw();
		/** */
		void	tidTooLong() const throw();
		/** */
		void	aidTooLong() const throw();
		/** */
		void	ctagTooLong() const throw();
		/** */
		void	ctagFieldMissing() const throw();
		/** */
		void	ctagInvalid() const throw();
		/** */
		void	terminatorMissing() const throw();
		/** */
		void	print(const char* s) const throw();
	};

}
}
}
}

#endif
