/*
   Copyright (C) 2004 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangments/agreements contact
   the copyright holder:

   Michael N. Moran
   5009 Old Field Ct.         mike@mnmoran.org
   Kennesaw, GA, USA 30144    http://mnmoran.org
*/

#ifndef _oscl_tristate_itc_dist_reqapih_
#define _oscl_tristate_itc_dist_reqapih_
#include "oscl/mt/itc/mbox/sap.h"
#include "oscl/mt/itc/mbox/srvreq.h"

/** */
namespace Oscl {
/** */
namespace TriState {
/** */
namespace DistReq {

/** */
class Api {
	public:
		/** */
		typedef Mt::Itc::SAP<TriState::DistReq::Api>		SAP;
		/** */
		typedef Mt::Itc::ConcreteSAP<TriState::DistReq::Api>	ConcreteSAP;
	public:
		/** */
		class AssertPayload {};
		/** */
		class NegatePayload {};
		/** */
		class InhibitPayload {};
	public:
		/** */
		typedef Mt::Itc::SrvRequest<	TriState::DistReq::Api,
										AssertPayload
										>	AssertReq;
		/** */
		typedef Mt::Itc::SrvRequest<	TriState::DistReq::Api,
										NegatePayload
										>	NegateReq;
		/** */
		typedef Mt::Itc::SrvRequest<	TriState::DistReq::Api,
										InhibitPayload
										>	InhibitReq;
	public:
		/** */
		virtual void request(AssertReq& msg) throw()=0;
		/** */
		virtual void request(NegateReq& msg) throw()=0;
		/** */
		virtual void request(InhibitReq& msg) throw()=0;
	};

}
}
}

#endif
